Public Class FormEditCircuit

    Public Pts() As System.Windows.Forms.Button
    Public SelectedPoint As Integer = -1

    Private _Func As New Dictionary(Of String, Button)
    Private _PtClick As Boolean = False
    Private _Bmp1, _Bmp2 As Bitmap
    Private _Gr As Graphics

    Public Sub SelectPoint(ByVal Pt As Integer)

        ' Enregistrement du point
        Me.SelectedPoint = Pt

        ' Recoloriage
        For Each bt As Button In Me.Pts
            bt.BackColor = Color.LightSkyBlue
        Next
        If Pt <> -1 Then
            Me.Pts(Pt).BackColor = Color.LightGreen
            'If ModuleAxis.Enabled Then MyCircuit.Points(Pt).AxisLoad()
        End If


        ' Recoloriage des fleches
        Me.RefreshFleches(Pt)

        ' Coloriage des fonctions
        If Pt = -1 Then
            For Each f As String In Me._Func.Keys
                Me._Func(f).Visible = False
            Next
        Else
            For Each f As String In Me._Func.Keys
                Me._Func(f).Visible = True
                If MyCircuit.Points(Me.SelectedPoint).AllFunc.Contains(f) Then
                    Me._Func(f).BackColor = Color.LightGreen
                Else
                    Me._Func(f).BackColor = Color.LightPink
                End If
            Next
        End If

        Me.Refresh()

    End Sub

    Private Sub FormEditionCircuit_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ' Chargement de l'image de fond
        _Bmp1 = New Bitmap(MyCircuit.ImgFile)
        _Bmp2 = New Bitmap(_Bmp1.Width + 2 * MyCircuit.Marge, _Bmp1.Height + 2 * MyCircuit.Marge + 30)
        _Gr = Graphics.FromImage(_Bmp2)

        With Me.PictureCircuit
            .Top = 0
            .Left = 0
            .Height = _Bmp2.Height
            .Width = _Bmp2.Width
            .Image = _Bmp2
        End With

        ' Points d'action
        Dim l As Integer = 3
        Dim h As Integer = Me.Annuler.Top
        For Each f As String In MyCircuit.DescFunc.Keys
            Me._Func.Add(f, New Button)
            Me.Controls.Add(Me._Func(f))
            With Me._Func(f)
                .Margin = Me.Annuler.Margin
                .Name = f
                .Height = Me.Annuler.Height
                .Width = 40
                .FlatStyle = FlatStyle.Flat
                .BackColor = Color.Gray
                .Left = l
                .Top = h
                .Text = f
                AddHandler .Click, AddressOf PtAction_Click
                'l += .Width + 3
                h -= .Height + 3
            End With
        Next

        ' Chargement des points
        LoadPoints()
        Me.SelectPoint(-1)

    End Sub

    Public Sub LoadPoints()
        ' Suppression des points
        If Not (Pts Is Nothing) Then
            For Each Pt As System.Windows.Forms.Button In Pts
                Me.Controls.Remove(Pt)
            Next
        End If

        ' Chargement des boutons
        ReDim Pts(0 To MyCircuit.NbPoints - 1)
        For i As Integer = 0 To MyCircuit.NbPoints - 1
            Pts(i) = New System.Windows.Forms.Button
            Me.Controls.Add(Pts(i))
            With Pts(i)
                .Name = "Pts" + CStr(i)
                .Height = 25
                .Width = 20
                .FlatStyle = FlatStyle.Flat
                .BackColor = Color.SkyBlue
                .Left = MyCircuit.Points(i).PosX + MyCircuit.Marge
                .Top = MyCircuit.Points(i).PosY + MyCircuit.Marge
                .Text = MyCircuit.Points(i).Symbole
                AddHandler .MouseDown, AddressOf Pts_MouseDown
                AddHandler .DragEnter, AddressOf Pts_DragEnter
                AddHandler .DragDrop, AddressOf Pts_DragDrop
                AddHandler .MouseLeave, AddressOf Pts_MouseLeave
                .AllowDrop = True
            End With
        Next

        ' Chargement de l'image de font
        Me.SelectPoint(-1)

        ' On met l'image en arrire plan
        Me.PictureCircuit.SendToBack()

    End Sub

    Public Sub RefreshFleches(ByVal Num As Integer)

        ' Alignement du texte
        Dim Sf As New StringFormat
        Sf.LineAlignment = StringAlignment.Center
        Sf.Alignment = StringAlignment.Center

        ' Chargement de l'image
        _Gr.Clear(Color.White)
        _Gr.DrawImage(_Bmp1, New Rectangle(MyCircuit.Marge, MyCircuit.Marge, _Bmp1.Width, _Bmp1.Height))

        ' Trac des flches
        For i As Integer = 0 To MyCircuit.NbPoints - 1
            For Each Dir As String In MyCircuit.Points(i).Successeurs.Keys
                If Num = -1 Or Num = i Then
                    Dim j As Integer = MyCircuit.Points(i).Successeurs(Dir).Numero

                    Dim Txt As String = Dir
                    If MyCircuit.Points(i).Vitesses(Dir) <> "1" Then Txt &= ",V" & MyCircuit.Points(i).Vitesses(Dir)
                    If MyCircuit.Points(i).Distances(Dir) <> 1 Then Txt &= ",L" & CStr(MyCircuit.Points(i).Distances(Dir))

                    Dim Theta, Theta1, Theta2, Theta3, Theta4 As Double
                    Theta2 = Math.Atan(CDbl(Pts(i).Height) / CDbl(Pts(i).Width))
                    Theta1 = Math.PI - Theta2
                    Theta3 = -Theta2
                    Theta4 = Theta2 - Math.PI
                    If Pts(i).Left = Pts(j).Left Then
                        If Pts(i).Top >= Pts(j).Top Then
                            Theta = -Math.PI / 2
                        Else
                            Theta = Math.PI / 2
                        End If
                    ElseIf Pts(i).Left > Pts(j).Left Then
                        Theta = Math.Atan((Pts(i).Top - Pts(j).Top) / (Pts(j).Left - Pts(i).Left))
                    Else
                        Theta = Math.PI + Math.Atan((Pts(i).Top - Pts(j).Top) / (Pts(j).Left - Pts(i).Left))
                        If Theta > Math.PI Then Theta = Theta - 2 * Math.PI
                    End If

                    Dim X1, X2, X3, Y1, Y2, Y3 As Integer
                    If Theta >= Theta3 And Theta <= Theta2 Then
                        X1 = Pts(j).Left + Pts(j).Width
                        Y1 = Pts(j).Top + Pts(j).Height / 2 - Pts(j).Width / 2 * Math.Tan(Theta)
                    ElseIf Theta >= Theta2 And Theta <= Theta1 Then
                        If Pts(i).Left = Pts(j).Left Then
                            X1 = Pts(j).Left + Pts(j).Width / 2
                        Else
                            X1 = Pts(j).Left + Pts(j).Width / 2 + Pts(j).Height / (2 * Math.Tan(Theta))
                        End If
                        Y1 = Pts(j).Top
                    ElseIf Theta >= Theta4 And Theta <= Theta3 Then
                        If Pts(i).Left = Pts(j).Left Then
                            X1 = Pts(j).Left + Pts(j).Width / 2
                        Else
                            X1 = Pts(j).Left + Pts(j).Width / 2 + Pts(j).Height / (2 * Math.Tan(-Theta))
                        End If
                        Y1 = Pts(j).Top + Pts(j).Height
                    Else
                        X1 = Pts(j).Left
                        Y1 = Pts(j).Top + Pts(j).Height / 2 + Pts(j).Width / 2 * Math.Tan(Theta)
                    End If

                    X2 = X1 + 12 * Math.Cos(Theta + Math.PI / 10)
                    Y2 = Y1 - 12 * Math.Sin(Theta + Math.PI / 10)
                    X3 = X1 + 12 * Math.Cos(Theta - Math.PI / 10)
                    Y3 = Y1 - 12 * Math.Sin(Theta - Math.PI / 10)

                    _Gr.DrawLine(New Pen(Color.SkyBlue, 2), X1, Y1, X2, Y2)
                    _Gr.DrawLine(New Pen(Color.SkyBlue, 2), X1, Y1, X3, Y3)

                    'Gr.DrawLine(New Pen(Color.SkyBlue, 2), CInt(Me.Pts(i).Left + Me.Pts(i).Width / 2), CInt(Me.Pts(i).Top + Me.Pts(i).Height / 2), CInt(Me.Pts(j).Left + Me.Pts(j).Width / 2), CInt(Me.Pts(j).Top + Me.Pts(j).Height / 2))
                    _Gr.DrawLine(New Pen(Color.SkyBlue, 2), CInt(Me.Pts(i).Left + Me.Pts(i).Width / 2), CInt(Me.Pts(i).Top + Me.Pts(i).Height / 2), X1, Y1)
                    _Gr.DrawString(Txt, New Font("Arial", 8, FontStyle.Bold), Brushes.Red, CInt(((Me.Pts(i).Left + Me.Pts(i).Width / 2) + (Me.Pts(j).Left + Me.Pts(j).Width / 2)) / 2), CInt(((Me.Pts(i).Top + Me.Pts(i).Height / 2) + (Me.Pts(j).Top + Me.Pts(j).Height / 2)) / 2), Sf)
                End If
            Next
        Next

    End Sub

#Region "Drap drop"

    Private Sub Pts_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)

        Dim i As Integer = System.Array.IndexOf(Pts, sender)
        Dim DejaSelectione As Boolean = (i = Me.SelectedPoint)
        _PtClick = True

        ' Affichage des flches
        SelectPoint(i)

        ' Drag and drop
        Pts(i).DoDragDrop(CStr(i), DragDropEffects.Copy)

        ' Edition d'un point
        If _PtClick Then
            If DejaSelectione Then
                ' On a dja cliqu
                Dim Dial As New FormEditPoint
                Dial.Charge(i)
                Dial.ShowDialog(Me)
                Dial.Dispose()
            Else
                ' On vient de cliquer
                For Each f As String In Me._Func.Keys
                    Me._Func(f).Visible = True
                    If MyCircuit.Points(Me.SelectedPoint).AllFunc.Contains(f) Then
                        Me._Func(f).BackColor = Color.LightGreen
                    Else
                        Me._Func(f).BackColor = Color.LightPink
                    End If
                Next
            End If
        End If

        ' Restrauration de l'affichage
        Me.SelectPoint(Me.SelectedPoint)

    End Sub

    Private Sub Pts_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs)
        _PtClick = False
    End Sub

    Private Sub Pts_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs)
        If (e.Data.GetDataPresent(DataFormats.Text)) Then
            Dim i As Integer = System.Array.IndexOf(Pts, sender)
            Dim j As Integer = e.Data.GetData(DataFormats.Text).ToString
            If i <> j Then
                e.Effect = DragDropEffects.Copy
            Else
                ' on interdit le drop sur lui mme
                e.Effect = DragDropEffects.None
            End If
        End If
    End Sub

    Private Sub Pts_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs)
        Dim Dst As Integer = System.Array.IndexOf(Pts, sender)
        Dim Src As Integer = e.Data.GetData(DataFormats.Text).ToString

        ' On regarde si le lien existe
        Dim Res As String = ""
        For Each Dir As String In MyCircuit.Points(Src).Successeurs.Keys
            If Dst = MyCircuit.Points(Src).Successeurs(Dir).Numero Then
                Res = Dir
                Exit For
            End If
        Next

        If Res = "" Then
            Try
                Dim Direction As String = InputBox("Direction", "Cration d'un nouveau lien")
                If Not MyCircuit.AllDest.Contains(Direction) Then
                    MsgBox("Valeur incorrecte, ajout annul", MsgBoxStyle.Exclamation  or MsgBoxStyle.OkOnly)
                    Exit Sub
                End If
                If MyCircuit.Points(Src).Successeurs.ContainsKey(Direction) Then
                    MsgBox("Valeur incorrecte, ajout annul", MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly)
                    Exit Sub
                End If

                Dim Distance As Integer = CInt(InputBox("Distance", "Cration d'un nouveau lien", "1"))
                If Distance <= 0 Then
                    MsgBox("Valeur incorrecte, ajout annul", MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly)
                    Exit Sub
                End If

                Dim Vitesse As String = InputBox("Vitesse", "Cration d'un nouveau lien", "1")
                If Not MyCircuit.AllVit.Contains(Vitesse) Then
                    MsgBox("Valeur incorrecte, ajout annul", MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly)
                    Exit Sub
                End If
                If Vitesse = "M" Then
                    MsgBox("Vitesse interdite dans l'diteur", MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly)
                    Exit Sub
                End If

                MyCircuit.Points(Src).EditAjouterLien(Direction, MyCircuit.Points(Dst), Vitesse, Distance)

            Catch ex As Exception
                MsgBox("Valeur incorrecte, ajout annul", MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly)
            End Try
        Else
            If MsgBox("Voulez-vous vraiment supprimer le lien ?", MsgBoxStyle.YesNo Or MsgBoxStyle.YesNo, "Lien existant") = MsgBoxResult.Yes Then
                MyCircuit.Points(Src).EditSupprimerLien(Res)
            End If
        End If

    End Sub

#End Region

    Private Sub Annuler_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Annuler.Click
        Me.Close()
    End Sub

    Private Sub Nouveau_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Nouveau.Click
        MyCircuit.NewPoint()
        Me.LoadPoints()
    End Sub

    Private Sub PictureCircuit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureCircuit.Click
        Me.SelectPoint(-1)
    End Sub

    Private Sub PtAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim f As Button = sender
        If MyCircuit.Points(Me.SelectedPoint).AllFunc.Contains(f.Name) Then
            MyCircuit.Points(Me.SelectedPoint).FuncRemove(f.Name)
        Else
            MyCircuit.Points(Me.SelectedPoint).FuncAdd(f.Name)
        End If
        Me.SelectPoint(Me.SelectedPoint)
    End Sub

End Class