Public Class FormMissionManu

    Private _Agv As AgvGeneric
    Private _Separateur As String = "+"

    Public Sub New(ByVal Agv As AgvGeneric)
        ' Cet appel est requis par le Concepteur Windows Form.
        InitializeComponent()
        ' Ajoutez une initialisation quelconque aprs l'appel InitializeComponent().
        Me._Agv = Agv
    End Sub

    Private Sub FormMissionManu_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ' Vrification nombre de missions
        If Me._Agv.NbMissions = 0 Then
            MsgBox("Il faut commencer par dfinir la position de l'AGV", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly)
            Me.Close()
            Exit Sub
        ElseIf Me._Agv.LastMission.Etat = MissionGeneric.Etats.Mission_Cancelled Then
            MsgBox("Il faut commencer par dfinir la position de l'AGV", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly)
            Me.Close()
            Exit Sub
        End If

        LabelPtDepart.Text = Me._Agv.LastMission.PositionFinale.Position.Description

    End Sub

    Private Sub Lancer()
        ' Nouvelle mission
        Me._Agv.NouvelleMission(Ordres.Text.Replace(" ", ""))
        Me.Close()
    End Sub

    Private Sub LancerMission_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LancerMission.Click
        Lancer()
    End Sub

    Private Sub Ordres_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Ordres.KeyUp
        If e.KeyCode = Keys.Enter Then
            Lancer()
        End If
    End Sub

    Private Sub Ordres_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Ordres.TextChanged

        ' remplacement des ordres spciaux
        If Me.Ordres.Text.Contains(_Separateur) Then
            Dim pf As Point = MyCircuit.GetPointByRef(Me.Ordres.Text.Split(_Separateur)(1))
            If pf IsNot Nothing Then
                Me.Ordres.Text = Me.Ordres.Text.Split(_Separateur)(0)
                Dim p As EtatAgv
                If Me.Ordres.Text = "" Then
                    p = Me._Agv.LastMission.PositionFinale
                Else
                    p = CalculEtatFinal(Me._Agv, Me._Agv.LastMission.PositionFinale, Me.Ordres.Text)
                End If
                Me.Ordres.Text &= ModuleTransport.CalculMission(Me._Agv, p, pf)
                Me.Ordres.Select(Me.Ordres.Text.Length, 0)
                Me.Ordres.ScrollToCaret()
            End If
        End If

        If IsMissionValide(Me._Agv, Me._Agv.LastMission.PositionFinale, Me.Ordres.Text.Replace(" ", "")) Then
            LancerMission.Enabled = True
            Me.LabelPtArrivee.Text = CalculEtatFinal(Me._Agv, Me._Agv.LastMission.PositionFinale, Me.Ordres.Text.Replace(" ", "")).Position.Description
        Else
            LancerMission.Enabled = False
            Me.LabelPtArrivee.Text = "?"
        End If

        ResumeMission.Text = CalculResume(Me._Agv, Me._Agv.LastMission.PositionFinale, Me.Ordres.Text.Replace(" ", ""))

    End Sub

    Private Sub Annuler_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Annuler.Click
        Me.Close()
    End Sub

End Class