Public Class FormPrincipale

    Public AllMissions As New List(Of MissionGeneric)

    Private Sub FormPrincipale_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Click
        Me.RefreshList()
    End Sub

    Private Sub FormPrincipale_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        TelnetSrv.DoStop()
    End Sub

    Private Sub FormPrincipale_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ' Initialisation de la camra
        Dim args As New List(Of String)(Environment.GetCommandLineArgs())
        ModuleAxis.Enabled = False ' args.Contains("-axis") Or True
        ModuleAxis.DoAxisInit()

        '  Dim Args As New List(Of String)(Environment.GetCommandLineArgs())
        ' Args = Args

        ' Ouverture du circuit
        My.Settings.Circuit = "C:\Documents and Settings\Supervision\Mes documents\AGV\Circuits\TP.png"
        If System.IO.File.Exists(My.Settings.Circuit) Then
            MyCircuit = New Circuit(My.Settings.Circuit)
        Else
            ' Selection du circuit
            Dim Dlg As OpenFileDialog = New OpenFileDialog
            Dlg.Filter = "Fichier PNG (*.png)|*.png"
            Dlg.ShowDialog()
            Dim File As String = Dlg.FileName
            If System.IO.File.Exists(File) Then
                ' Modification du paramtre
                My.Settings.Circuit = File
                ' Chargement du circuit
                MyCircuit = New Circuit(File)
            Else
                MsgBox("Circuit non trouv.", MsgBoxStyle.OkOnly)
                End
            End If
        End If

        ' Initialisation de la communication srie
        Dim Rs232Cubloc As New Rs232Cubloc(My.Settings.SerialPortAgv1, Me)
        MyAgvs.Add(New AgvCubloc(1, Rs232Cubloc))

        Dim Rs232Agv2 As New Rs232Automate(My.Settings.SerialPortAgv2, Me)
        MyAgvs.Add(New AgvAutomate(Rs232Agv2))

        ' Niveau de scurit par dfaut
        NiveauSecu = 0
        If args.Contains("-admin") Then NiveauSecu = 100

        ' Initialisation de l'indicateur de charge
        'ChargeVal.Left = 2
        'ChargeVal.Width = ChargeVal.Parent.Width - 4
        'ChargeVal.Top = 2
        'ChargeVal.Height = ChargeVal.Parent.Height - 4
        'ChargeTimer = New System.Windows.Forms.Timer
        'ChargeTimer.Interval = 50
        'ChargeTimer.Enabled = True

        _FormPrincipale = Me

        TelnetSrv.DoStart()

    End Sub

#Region "Liste missions et rapport"

    Public Sub RefreshList()

        Dim s As Integer = ListMissions.SelectedIndex
        ListMissions.Items.Clear()

        ' Ajout de toutes les missions
        For Each m As MissionGeneric In Me.AllMissions
            ListMissions.Items.Add(m.TitreListe)
        Next

        ' Reselectionne l'item
        ListMissions.SelectedIndex = s
        LoadRapport(s)

    End Sub

    Private Sub ListMissions_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListMissions.SelectedIndexChanged
        LoadRapport(ListMissions.SelectedIndex)
    End Sub

    Private Sub LoadRapport(ByVal Ref As Integer)

        ' Rapport vierge
        GroupRapport.Text = "Rapport de mission"
        RichRapport.Text = ""
        If Ref = -1 Then
            Exit Sub
        End If
        If Me.AllMissions(Ref).Etat = MissionGeneric.Etats.Recalage_Manuel Then
            Exit Sub
        End If

        ' Chargement du rapport
        GroupRapport.Text = Me.AllMissions(Ref).TitreRapport
        Me.AllMissions(Ref).RichRapport(Me.RichRapport)

    End Sub

#End Region

#Region "Charge batterie"
    'Private WithEvents ChargeTimer As System.Windows.Forms.Timer

    'Public Sub RefreshCharge(ByVal Charge As Integer)
    ' Dim Hauteur As Integer = CInt((ChargeVal.Parent.Height - 4) * Charge / 100)
    ' ChargeVal.Top = ChargeVal.Parent.Height - Hauteur - 2
    ' ChargeVal.Height = Hauteur

    ' Select Case Charge
    '  Case 80 To 100
    '    ChargeVal.BackColor = Color.Green
    ' Case 50 To 79
    '    ChargeVal.BackColor = Color.Orange
    '    Case 0 To 49
    '      ChargeVal.BackColor = Color.Red
    'End Select

    'Select Case Charge
    'Case 50 To 100
    'ChargeVal.BackColor = Color.FromArgb(CInt((100 - Charge) * 255 / 50), CInt(Charge * 255 / 100), 0)
    'Case 0 To 49
    'ChargeVal.BackColor = Color.FromArgb(255, CInt(Charge * 255 / 100), 0)
    'End Select

    'ChargeVal.BackColor = Color.FromArgb(CInt((100 - Charge) * 255 / 100), CInt(Charge * 255 / 100), 0)

    'End Sub

    'Private Function GetCharge() As Integer
    'Return 100
    'Return (Charge + 100) Mod 101
    'End Function

    'Private Sub ChargeTimer_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles ChargeTimer.Tick
    '    Charge = GetCharge()
    '    RefreshCharge(Charge)
    'End Sub

    'Private Sub Charge_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ChargeVal.MouseClick, ChargeFond.MouseClick
    '    MsgBox("Charge : " & CStr(Charge) & "%", MsgBoxStyle.Information, "Charge de la batterie")
    'End Sub

#End Region

#Region "Menu"

    Private Sub MenuChariotDeplacement_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuAgv1DefPos.Click
        Dim Dial As New FormRecalage(MyAgvs(0))
        Dial.ShowDialog(Me)
        Dial.Dispose()
    End Sub

    Private Sub MenuAppQuitter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuAppQuitter.Click
        End
    End Sub

    Private Sub MenuChariotInfo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuAgv1Info.Click
        FormInfoAgv.Show()
    End Sub

    Private Sub MenuAppInit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuAppInit.Click
        For Each a As AgvGeneric In MyAgvs
            a.Missions.Clear()
        Next
        Me.AllMissions.Clear()
        ListMissions.SelectedIndex = -1
        RefreshList()
    End Sub

    Private Sub MenuChariotInit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuAgv1Init.Click
        ' Envoi d'un reset
        MyAgvs(0).Envoyer("#RS")
    End Sub

    Private Sub MenuAppOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuAppOpen.Click

        ' Biote de dialogue
        Dim Dlg As OpenFileDialog = New OpenFileDialog
        Dlg.Filter = "Fichier PNG (*.png)|*.png"
        Dlg.ShowDialog()
        Dim File As String = Dlg.FileName

        If System.IO.File.Exists(File) Then
            ' Modification du paramtre
            My.Settings.Circuit = File
            ' Chargement du circuit
            MyCircuit = New Circuit(File)
            ' Reset de l'appli
            For Each a As AgvGeneric In MyAgvs
                a.Missions.Clear()
            Next
            Me.AllMissions.Clear()
            ListMissions.SelectedIndex = -1
            RefreshList()
        End If

    End Sub

    Private Sub PictureRapport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureRapport.Click
        MyAgvs(0).Envoyer("#AU")
    End Sub

    Private Sub MenuMaintenanceRearm_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        MyAgvs(0).Envoyer("#VA")
    End Sub

    Private Sub MenuAppModif_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuAppModif.Click
        Dim Dial As New FormEditCircuit
        Dial.ShowDialog(Me)
        Dial.Dispose()
    End Sub

    Public MyFormBoussole As FormBoussole
    Private Sub MenuAgv1Boussole_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuAgv1Boussole.Click
        MyFormBoussole = New FormBoussole
        MyFormBoussole.ShowDialog(Me)
        MyFormBoussole.Dispose()
        MyFormBoussole = Nothing
    End Sub

    Private Sub MenuAgv1Joystick_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuAgv1Joystick.Click
        Dim Dial As New FormJoystick
        Dial.ShowDialog(Me)
        Dial.Dispose()
    End Sub

    Private Sub MenuAgv1Clavier_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuAgv1Clavier.Click
        Dim Dial As New FormClavier
        Dial.ShowDialog(Me)
        Dial.Dispose()
    End Sub

    Private Sub MenuAgv1Wiimote_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuAgv1Wiimote.Click
        Dim Dial As New FormWiimote
        Dial.ShowDialog(Me)
        Dial.Dispose()
    End Sub

    Private Sub MenuAgv1MissionManu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuAgv1MissionManu.Click
        Dim Dial As New FormMissionManu(MyAgvs(0))
        Dial.ShowDialog(Me)
        Dial.Dispose()
    End Sub

    Private Sub MenuAgv1MissionAuto_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuAgv1MissionAuto.Click
        Dim Dial As New FormMissionAuto(MyAgvs(0))
        Dial.ShowDialog(Me)
        Dial.Dispose()
    End Sub

    Private Sub MenuAgv2DefPos_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuAgv2DefPos.Click
        Dim Dial As New FormRecalage(MyAgvs(1))
        Dial.ShowDialog(Me)
        Dial.Dispose()
    End Sub

    Private Sub MenuAgv2MissionAuto_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuAgv2MissionAuto.Click
        Dim Dial As New FormMissionAuto(MyAgvs(1))
        Dial.ShowDialog(Me)
        Dial.Dispose()
    End Sub

    Private Sub MenuAgv2MissionManu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuAgv2MissionManu.Click
        Dim Dial As New FormMissionManu(MyAgvs(1))
        Dial.ShowDialog(Me)
        Dial.Dispose()
    End Sub

    Private Sub MenuAgv2Com_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuAgv2Com.Click
        FormDebug2.Show()
    End Sub

    Private Sub MenuAgv1Com_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuAgv1Com.Click
        FormDebug1.Show()
    End Sub

    Private Sub MenuAgv1RearmAu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuAgv1RearmAu.Click
        MyAgvs(0).Envoyer("#VA")
    End Sub

    Private Sub MenuAgv2Demo1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        If MyAgvs(1).NbMissions = 0 Then
            MsgBox("Il faut commencer par dfinir la position de l'AGV", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly)
            Exit Sub
        End If
        Dim M As String = ""
        M &= CalculMission(MyAgvs(1), MyAgvs(1).LastMission.PositionFinale, MyCircuit.GetPointByRef("de2"))
        M &= "DDDEARCD"
        MyAgvs(1).NouvelleMission(M)
    End Sub

    Private Sub MenuAgv2Demo2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        If MyAgvs(1).NbMissions = 0 Then
            MsgBox("Il faut commencer par dfinir la position de l'AGV", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly)
            Exit Sub
        End If
        Dim M As String = ""
        M &= CalculMission(MyAgvs(1), MyAgvs(1).LastMission.PositionFinale, MyCircuit.GetPointByRef("ar2"))
        MyAgvs(1).NouvelleMission(M)
    End Sub

    Private Sub InfluenceDunCalculateurToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuPedagoCalc.Click
        Dim Dial As New FormCalculateur
        Dial.ShowDialog(Me)
        Dial.Dispose()
    End Sub

#End Region

#Region "Mot de passe"

    Private _NiveauSecu As Integer
    Public Property NiveauSecu() As Integer
        Get
            Return _NiveauSecu
        End Get
        Set(ByVal value As Integer)
            Me._NiveauSecu = value
            ' Application
            Me.MenuAppInit.Visible = (Me._NiveauSecu >= 100)
            Me.MenuAppModif.Visible = (Me._NiveauSecu >= 100)
            Me.MenuAppOpen.Visible = (Me._NiveauSecu >= 20)
            ' AGV1
            Me.MenuAgv1MissionAuto.Visible = (Me._NiveauSecu >= 10)
            Me.MenuAgv1Boussole.Visible = (Me._NiveauSecu >= 100)
            Me.MenuAgv1Clavier.Visible = (Me._NiveauSecu >= 100)
            Me.MenuAgv1Joystick.Visible = (Me._NiveauSecu >= 100)
            Me.MenuAgv1Wiimote.Visible = (Me._NiveauSecu >= 100)
            Me.MenuAgv1RearmAu.Visible = (Me._NiveauSecu >= 100)
            ' AGV2
            Me.MenuAgv2MissionAuto.Visible = (Me._NiveauSecu >= 10)
            ' Pdagogique
            Me.MenuPedago.Visible = (Me._NiveauSecu >= 100)
            Me.MenuPedagoCalc.Visible = (Me._NiveauSecu >= 100)
            ' Maintenance
            FormDebug1.ModifBt1.Enabled = (Me._NiveauSecu >= 20)
            FormDebug1.ModifVal1.Enabled = (Me._NiveauSecu >= 20)
            FormDebug1.ComText.Enabled = (Me._NiveauSecu >= 20)
            FormDebug1.ComBt.Enabled = (Me._NiveauSecu >= 20)
            FormDebug2.ModifBt2.Enabled = (Me._NiveauSecu >= 20)
            FormDebug2.ModifVal2.Enabled = (Me._NiveauSecu >= 20)
            FormDebug2.ComText.Enabled = (Me._NiveauSecu >= 20)
            FormDebug2.ComBt.Enabled = (Me._NiveauSecu >= 20)
            ' Demo
            Me.ButtonRemote.Visible = (Me._NiveauSecu >= 20)

            ' On cache les sparateurs inutiles
            'For Each _Menu As System.Windows.Forms.ToolStripMenuItem In MenuHaut.Items
            'MsgBox("titi")
            'Dim LastIsSeparator As Boolean = True
            'For Each _Item As System.Windows.Forms.ToolStripItem In _Menu.DropDownItems
            'MsgBox("tutu")
            'If _Item.Visible = True Then
            'MsgBox("tata")
            'If _Item.GetType.ToString.Contains("Separator") Then
            'MsgBox("toto")
            '_Item.Visible = Not LastIsSeparator
            'LastIsSeparator = True
            'Else
            'LastIsSeparator = False
            'End If
            'End If
            'Next
            'Next

        End Set
    End Property

    Private Sub PictureBox2_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles PictureBox2.Click
        Me.TextBox1.Text = ""
        Me.TextBox1.Visible = True
        Me.TextBox1.Focus()
    End Sub

    Private Sub TextBox1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TextBox1.KeyDown
        If e.KeyCode = Keys.Enter Then
            PassWord(Me.TextBox1.Text)
            Me.TextBox1.Text = ""
            Me.TextBox1.Visible = False
        ElseIf e.KeyCode = Keys.Escape Then
            PassWord()
            Me.TextBox1.Text = ""
            Me.TextBox1.Visible = False
        End If
    End Sub

    Private Sub TextBox1_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox1.LostFocus
        Me.TextBox1.Visible = False
    End Sub

    Private Sub PassWord(Optional ByVal MotDePasse As String = "")
        ' Change le niveau de scu
        MotDePasse = MotDePasse.ToLower
        Select Case MotDePasse
            Case "mauto"
                NiveauSecu = 10
            Case "demo"
                NiveauSecu = 20
            Case "cubloc"
                NiveauSecu = 100
            Case Else
                NiveauSecu = 0
        End Select
    End Sub

#End Region

#Region "Girophare"
    Private Sub TimerGirophare_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TimerGirophare.Tick
        If Me.SymboleArretUrgence.Visible Or Me.SymboleBouclier.Visible Or Me.SymboleObstacle.Visible Then
            Me.PictureGirophare.Visible = Not Me.PictureGirophare.Visible
        ElseIf Me.PictureGirophare.Visible Then
            Me.PictureGirophare.Visible = False
        End If
    End Sub
#End Region

#Region "Telnet"

    Dim WithEvents TelnetSrv As New MultiClientTcpListener(23)

    Private Sub TelnetSrv_ClientOpen(ByRef sender As MultiClientTcpListener.ClientHandler) Handles TelnetSrv.ClientOpen
        sender.WriteLine("Bienvenue sur la supervision des AGVs")
        sender.WriteLine("*************************************")
    End Sub

    Private Sub TelnetSrv_ClientReceiveLine(ByRef sender As MultiClientTcpListener.ClientHandler, ByVal Text As String) Handles TelnetSrv.ClientReceiveLine
        Text = Text.ToUpper
        Dim _Args() As String = Text.Split(" ")
        Dim Args As New List(Of String)(_Args)

        If Args(0) = "SET" Then
            If Args.Count <> 4 Then
                sender.WriteLine("=> SET : Mauvaise syntaxe")
                Exit Sub
            ElseIf Not (Args(1) = "AGV1" Or Args(1) = "AGV2") Then
                sender.WriteLine("=> SET : AGV inconnu")
                Exit Sub
            ElseIf Args(2) <> "AT" Then
                sender.WriteLine("=> SET : Mauvaise syntaxe")
                Exit Sub
            ElseIf MyCircuit.GetPointByRef(Args(3)) Is Nothing Then
                sender.WriteLine("=> SET : Point inconnu")
                Exit Sub
            Else
                Dim _Agv As AgvGeneric = MyAgvs(CInt(Args(1).Substring(3)) - 1)
                Dim Pt As Point = MyCircuit.GetPointByRef(Args(3))
                _Agv.NouveauRecalage(Pt)
                sender.WriteLine("=> SET : " & Args(1) & " AT " & Pt.Description)
            End If

        ElseIf Args(0) = "MISSION" Or Args(0) = "M" Then
            ' liste des arguments
            Args.RemoveAt(0)

            If Args.Count = 0 Then
                sender.WriteLine("=> MISSION : Aucun AGV")
                Exit Sub
            End If

            ' selection de l'agv
            If Args(0) <> "AGV1" And Args(0) <> "AGV2" Then
                sender.WriteLine("=> MISSION : AGV inconnu")
                Exit Sub
            End If
            Dim _Agv As AgvGeneric = MyAgvs(CInt(Args(0).Substring(3)) - 1)
            Args.RemoveAt(0)

            ' mission vide
            If Args.Count = 0 Then
                sender.WriteLine("=> MISSION : Mission vide")
                Exit Sub
            End If

            ' position non dfinie
            If _Agv.Missions.Count = 0 Then
                sender.WriteLine("=> MISSION : Position de l'AGV non dfinie")
                Exit Sub
            End If

            ' mission
            Dim _m As String = ""
            Dim _e As EtatAgv = _Agv.LastMission.PositionFinale
            For Each s As String In Args
                If _Agv.AllFunc.Contains(s) Then
                    _m &= s
                Else
                    Dim _pt As Point = MyCircuit.GetPointByRef(s)
                    If _pt Is Nothing Then
                        sender.WriteLine("=> MISSION : Point inconnu (" & s & ")")
                        Exit Sub
                    End If
                    _m &= ModuleTransport.CalculMission(_Agv, _e, _pt, True)
                    _e = CalculEtatFinal(_Agv, _Agv.LastMission.PositionFinale, _m)
                End If
            Next
            If Not IsMissionValide(_Agv, _Agv.LastMission.PositionFinale, _m) Then
                sender.WriteLine("=> MISSION : Mission erronee")
            Else
                _Agv.NouvelleMission(_m)
                sender.WriteLine("=> MISSION : Ok")
            End If

        ElseIf Args(0) = "GET" Then
            ' liste des arguments
            Args.RemoveAt(0)

            ' pas assez d'argument
            If Args.Count = 0 Then
                sender.WriteLine("=> GET : Mauvais argument")
                Exit Sub
            End If

            If Args(0) = "ALL" Then
                For Each m As MissionGeneric In Me.AllMissions
                    Dim l As String = "=> "
                    l &= "AGV" & (MyAgvs.IndexOf(m.Agv) + 1)
                    l &= " "
                    l &= m.Ordres
                    l &= " "
                    l &= m.OrdresDone
                    l &= " "
                    l &= m.Etat
                    l &= " "
                    l &= m.Distance
                    sender.WriteLine(l)
                Next
                sender.WriteLine("=> GET : Ok")
            Else
                sender.WriteLine("=> GET : Mauvais argument")
                Exit Sub
            End If

        ElseIf Args(0) = "EXIT" Then
            sender.DoStop()

        Else
            sender.WriteLine("=> Commande inconnue (" & Text & ")")

        End If
    End Sub

#End Region

    Private Sub ButtonRemote_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonRemote.Click
        Dim Dial As New FormDemo
        Dial.ShowDialog(Me)
        Dial.Dispose()
    End Sub

End Class
