''' <summary>La classe IniReader peut lire et crire des donnes dans des fichiers INI.</summary>
''' <remarks>Cette classe utilisae des fontions de l'API de Win32.</remarks>
Public Class ClassIniReader

    ' Variables prives
    Private m_Filename As String
    Private Const MAX_ENTRY As Integer = 32768

    ' Fonctions de l'API Win32
    <System.Runtime.InteropServices.DllImport("KERNEL32.DLL", EntryPoint:="GetPrivateProfileIntA", SetLastError:=False, CharSet:=System.Runtime.InteropServices.CharSet.Ansi, ExactSpelling:=True, CallingConvention:=System.Runtime.InteropServices.CallingConvention.StdCall)> _
    Private Shared Function GetPrivateProfileInt(ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal nDefault As Integer, ByVal lpFileName As String) As Integer
    End Function
    <System.Runtime.InteropServices.DllImport("KERNEL32.DLL", EntryPoint:="WritePrivateProfileStringA", SetLastError:=False, CharSet:=System.Runtime.InteropServices.CharSet.Ansi, ExactSpelling:=True, CallingConvention:=System.Runtime.InteropServices.CallingConvention.StdCall)> _
    Private Shared Function WritePrivateProfileString(ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As String, ByVal lpFileName As String) As Integer
    End Function
    <System.Runtime.InteropServices.DllImport("KERNEL32.DLL", EntryPoint:="GetPrivateProfileStringA", SetLastError:=False, CharSet:=System.Runtime.InteropServices.CharSet.Ansi, ExactSpelling:=True, CallingConvention:=System.Runtime.InteropServices.CallingConvention.StdCall)> _
    Private Shared Function GetPrivateProfileString(ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As System.Text.StringBuilder, ByVal nSize As Integer, ByVal lpFileName As String) As Integer
    End Function
    <System.Runtime.InteropServices.DllImport("KERNEL32.DLL", EntryPoint:="WritePrivateProfileStructA", SetLastError:=False, CharSet:=System.Runtime.InteropServices.CharSet.Ansi, ExactSpelling:=True, CallingConvention:=System.Runtime.InteropServices.CallingConvention.StdCall)> _
    Private Shared Function WritePrivateProfileStruct(ByVal lpszSection As String, ByVal lpszKey As String, ByVal lpStruct() As Byte, ByVal uSizeStruct As Integer, ByVal szFile As String) As Integer
    End Function
    <System.Runtime.InteropServices.DllImport("KERNEL32.DLL", EntryPoint:="GetPrivateProfileStructA", SetLastError:=False, CharSet:=System.Runtime.InteropServices.CharSet.Ansi, ExactSpelling:=True, CallingConvention:=System.Runtime.InteropServices.CallingConvention.StdCall)> _
    Private Shared Function GetPrivateProfileStruct(ByVal lpszSection As String, ByVal lpszKey As String, ByVal lpStruct() As Byte, ByVal uSizeStruct As Integer, ByVal szFile As String) As Integer
    End Function
    <System.Runtime.InteropServices.DllImport("KERNEL32.DLL", EntryPoint:="GetPrivateProfileSectionNamesA", SetLastError:=False, CharSet:=System.Runtime.InteropServices.CharSet.Ansi, ExactSpelling:=True, CallingConvention:=System.Runtime.InteropServices.CallingConvention.StdCall)> _
    Private Shared Function GetPrivateProfileSectionNames(ByVal lpszReturnBuffer() As Byte, ByVal nSize As Integer, ByVal lpFileName As String) As Integer
    End Function
    <System.Runtime.InteropServices.DllImport("KERNEL32.DLL", EntryPoint:="WritePrivateProfileSectionA", SetLastError:=False, CharSet:=System.Runtime.InteropServices.CharSet.Ansi, ExactSpelling:=True, CallingConvention:=System.Runtime.InteropServices.CallingConvention.StdCall)> _
    Private Shared Function WritePrivateProfileSection(ByVal lpAppName As String, ByVal lpString As String, ByVal lpFileName As String) As Integer
    End Function
    <System.Runtime.InteropServices.DllImport("KERNEL32.DLL", EntryPoint:="GetPrivateProfileSectionA", SetLastError:=False, CharSet:=System.Runtime.InteropServices.CharSet.Ansi, ExactSpelling:=True, CallingConvention:=System.Runtime.InteropServices.CallingConvention.StdCall)> _
    Private Shared Function GetPrivateProfileSection(ByVal lpAppName As String, ByVal lpReturnedBuffer As IntPtr, ByVal nSize As Integer, ByVal lpFileName As String) As Integer
    End Function

    Public Sub New(ByVal File As String)
        Filename = File
    End Sub

    Public Property Filename() As String
        Get
            Return m_Filename
        End Get
        Set(ByVal Value As String)
            m_Filename = Value
        End Set
    End Property

    Public Overloads Function ReadInteger(ByVal Section As String, ByVal Key As String, ByVal DefVal As Integer) As Integer
        Try
            Return GetPrivateProfileInt(Section, Key, DefVal, Filename)
        Catch
            Return DefVal
        End Try
    End Function
    Public Overloads Function ReadInteger(ByVal Section As String, ByVal Key As String) As Integer
        Return ReadInteger(Section, Key, 0)
    End Function
    Public Overloads Function ReadInteger(ByVal Key As String) As Integer
        Return ReadInteger(Key, 0)
    End Function

    Public Overloads Function ReadString(ByVal Section As String, ByVal Key As String, ByVal DefVal As String) As String
        Try
            Dim sb As New System.Text.StringBuilder(MAX_ENTRY)
            Dim Ret As Integer = GetPrivateProfileString(Section, Key, DefVal, sb, MAX_ENTRY, Filename)
            Return sb.ToString
        Catch
            Return DefVal
        End Try
    End Function
    Public Overloads Function ReadString(ByVal Section As String, ByVal Key As String) As String
        Return ReadString(Section, Key, "")
    End Function

    Public Overloads Function ReadLong(ByVal Section As String, ByVal Key As String, ByVal DefVal As Long) As Long
        Return Long.Parse(ReadString(Section, Key, DefVal.ToString))
    End Function
    Public Overloads Function ReadLong(ByVal Section As String, ByVal Key As String) As Long
        Return ReadLong(Section, Key, 0)
    End Function
    Public Overloads Function ReadLong(ByVal Key As String) As Long
        Return ReadLong(Key, 0)
    End Function

    Public Function ReadByteArray(ByVal Section As String, ByVal Key As String, ByVal Length As Integer) As Byte()
        If Length > 0 Then
            Try
                Dim Buffer(Length - 1) As Byte
                If GetPrivateProfileStruct(Section, Key, Buffer, Buffer.Length, Filename) = 0 Then
                    Return Nothing
                Else
                    Return Buffer
                End If
            Catch
                Return Nothing
            End Try
        Else
            Return Nothing
        End If
    End Function

    Public Overloads Function ReadBoolean(ByVal Section As String, ByVal Key As String, ByVal DefVal As Boolean) As Boolean
        Return Boolean.Parse(ReadString(Section, Key, DefVal.ToString))
    End Function
    Public Overloads Function ReadBoolean(ByVal Section As String, ByVal Key As String) As Boolean
        Return ReadBoolean(Section, Key, False)
    End Function

    Public Overloads Function Write(ByVal Section As String, ByVal Key As String, ByVal Value As Integer) As Boolean
        Try
            Return (WritePrivateProfileString(Section, Key, Value.ToString, Filename) <> 0)
        Catch
            Return False
        End Try
    End Function
    Public Overloads Function Write(ByVal Section As String, ByVal Key As String, ByVal Value As String) As Boolean
        Try
            Return (WritePrivateProfileString(Section, Key, Value, Filename) <> 0)
        Catch
            Return False
        End Try
    End Function
    Public Overloads Function Write(ByVal Section As String, ByVal Key As String, ByVal Value As Long) As Boolean
        Return Write(Section, Key, Value.ToString)
    End Function
    Public Overloads Function Write(ByVal Section As String, ByVal Key As String, ByVal Value() As Byte) As Boolean
        Try
            Return (WritePrivateProfileStruct(Section, Key, Value, Value.Length, Filename) <> 0)
        Catch
            Return False
        End Try
    End Function
    Public Overloads Function Write(ByVal Section As String, ByVal Key As String, ByVal Value As Boolean) As Boolean
        Return Write(Section, Key, Value.ToString)
    End Function

    ' <see cref="String">String</see>
    ''' <summary>Supprime une cl dans une section.</summary>
    ''' <param name="Section">Section de la cl  supprimer.</param>
    ''' <param name="Key">Cl  supprimer.</param>
    ''' <returns>Retourne True si la fonction s'est bien termine, False sinon.</returns>
    Public Function DeleteKey(ByVal Section As String, ByVal Key As String) As Boolean
        Try
            Return (WritePrivateProfileString(Section, Key, Nothing, Filename) <> 0)
        Catch
            Return False
        End Try
    End Function

    Public Function DeleteSection(ByVal Section As String) As Boolean
        Try
            Return WritePrivateProfileSection(Section, Nothing, Filename) <> 0
        Catch
            Return False
        End Try
    End Function

    Public Function GetSectionNames() As ArrayList
        GetSectionNames = New ArrayList()
        Dim Buffer(MAX_ENTRY) As Byte
        Dim BuffStr As String
        Dim PrevPos As Integer = 0
        Dim Length As Integer
        Try
            Length = GetPrivateProfileSectionNames(Buffer, MAX_ENTRY, Filename)
        Catch
            Exit Function
        End Try
        Dim ASCII As New System.Text.ASCIIEncoding()
        If Length > 0 Then
            BuffStr = ASCII.GetString(Buffer)
            Length = 0
            PrevPos = -1
            Do
                Length = BuffStr.IndexOf(ControlChars.NullChar, PrevPos + 1)
                If Length - PrevPos = 1 OrElse Length = -1 Then Exit Do
                Try
                    GetSectionNames.Add(BuffStr.Substring(PrevPos + 1, Length - PrevPos))
                Catch
                End Try
                PrevPos = Length
            Loop
        End If
    End Function

End Class
