Public Class FormBoussole

    Private _CapCourant As Integer = 0
    Private _CapASuivre As Integer = 0

    Private _Bmp As Bitmap
    Private _Gr As Graphics
    Private _Marge As Integer = 20

    ' Chariot
    Private _CD1 As Double = 1
    Private _CD2 As Double = 1.5
    Private _CD3 As Double = 0.3
    Private _CL(0 To 5) As Double
    Private _CT(0 To 5) As Double
    Private _CP(0 To 5) As System.Drawing.Point

    ' Roues
    Private _RD1 As Double = 0.25
    Private _RD2 As Double = 0.1
    Private _RD3 As Double = 0.2
    Private _RD4 As Double = 0.38
    Private _RD5 As Double = 0.48

    ' Roue avant
    Private _R1L(0 To 3) As Double
    Private _R1T(0 To 3) As Double
    Private _R1P(0 To 3) As System.Drawing.Point

    ' Roue arrire gauche
    Private _R2L(0 To 3) As Double
    Private _R2T(0 To 3) As Double
    Private _R2P(0 To 3) As System.Drawing.Point

    ' Roue arrire droite
    Private _R3L(0 To 3) As Double
    Private _R3T(0 To 3) As Double
    Private _R3P(0 To 3) As System.Drawing.Point

    ' Cible
    Private _FL(0 To 2) As Double
    Private _FT(0 To 2) As Double
    Private _FP(0 To 2) As System.Drawing.Point

    ' Rosace 1
    Private _X1D1 As Double = 0.15
    Private _X1D2 As Double = 0.8
    Private _X1P(0 To 7) As System.Drawing.Point

    ' Rosace 2
    Private _X2D1 As Double = 0.9
    Private _X2D2 As Double = 0.15
    Private _X2P(0 To 7) As System.Drawing.Point

    Private _BrushChariot As System.Drawing.SolidBrush = New System.Drawing.SolidBrush(Color.FromArgb(150, Color.Green))
    Private _BrushRoue As System.Drawing.SolidBrush = New System.Drawing.SolidBrush(Color.FromArgb(150, Color.White))
    Private _BrushCible As System.Drawing.SolidBrush = Brushes.Red
    Private _BrushRosace1 As System.Drawing.SolidBrush = New System.Drawing.SolidBrush(Color.FromArgb(255, 150, 150, 255))
    Private _BrushRosace2 As System.Drawing.SolidBrush = New System.Drawing.SolidBrush(Color.FromArgb(255, 100, 100, 255))

    Private _StringFormatCardinales As New StringFormat
    Private _FontCardinales = New Font("Arial", 12, FontStyle.Bold)

    Public Sub SetCapASuivre(ByVal Cap As Integer)
        _CapASuivre = Cap
        Me.RefreshRosace()
    End Sub

    Public Sub SetCapCourant(ByVal Cap As Integer)
        _CapCourant = Cap
        Me.RefreshRosace()
    End Sub

    Private Function MakePt(ByVal Longueur As Double, ByVal Angle As Double) As System.Drawing.Point
        Dim P As System.Drawing.Point
        P = New System.Drawing.Point(CDbl(PictureBox1.Width) / 2.0 + Longueur * (CDbl(PictureBox1.Width) / 2.0) * Math.Cos(Math.PI / 2.0 - Angle * Math.PI / 180.0), CDbl(PictureBox1.Height) / 2.0 - Longueur * (CDbl(PictureBox1.Width) / 2.0) * Math.Sin(Math.PI / 2.0 - Angle * Math.PI / 180.0))
        Return P
    End Function

    Private Sub RefreshRosace()
        _Gr.Clear(Color.Transparent)

        _Gr.FillEllipse(Brushes.LightGray, New Rectangle(0, 0, PictureBox1.Width - 1, PictureBox1.Height - 1))

        'Dim C As New System.Drawing.Point(CInt(PictureBox1.Width / 2), CInt(PictureBox1.Height / 2))

        ' Lignes
        'V2 Dim A1, B1 As System.Drawing.Point
        'V2 A1 = MakePt(0.8, _CapASuivre)
        'V2 B1 = MakePt(0.8, _CapCourant)
        'V1 Dim a As Double = 0 : Dim l As Double = 0
        'V1 a = _CapASuivre : l = 1
        'V1 Dim A1 As New System.Drawing.Point(PictureBox1.Width / 2 + l * (PictureBox1.Width / 2 - _Marge) * Math.Cos(Math.PI / 2 - CDbl(a) * Math.PI / 180), PictureBox1.Height / 2 - l * (PictureBox1.Width / 2 - _Marge) * Math.Sin(Math.PI / 2 - CDbl(a) * Math.PI / 180))
        'V1 a = _CapCourant : l = 1
        'V1 Dim B1 As New System.Drawing.Point(PictureBox1.Width / 2 + l * (PictureBox1.Width / 2 - _Marge) * Math.Cos(Math.PI / 2 - CDbl(a) * Math.PI / 180), PictureBox1.Height / 2 - l * (PictureBox1.Width / 2 - _Marge) * Math.Sin(Math.PI / 2 - CDbl(a) * Math.PI / 180))
        'V2 _Gr.DrawLine(New Pen(Color.Green, 2), C, A1)
        'V2 _Gr.DrawLine(New Pen(Color.Red, 2), C, B1)

        ' Rosaces 
        _Gr.FillPolygon(_BrushRosace1, _X1P)
        _Gr.FillPolygon(_BrushRosace2, _X2P)

        ' Points cardinaux
        Dim r As Double = 0.95
        _Gr.DrawString("N", _FontCardinales, _BrushRosace2, MakePt(r, 0), _StringFormatCardinales)
        _Gr.DrawString("S", _FontCardinales, _BrushRosace2, MakePt(r, 180), _StringFormatCardinales)
        _Gr.DrawString("E", _FontCardinales, _BrushRosace2, MakePt(r, 90), _StringFormatCardinales)
        _Gr.DrawString("O", _FontCardinales, _BrushRosace2, MakePt(r, 270), _StringFormatCardinales)

        ' Cible
        For i As Integer = 0 To 2
            _FP(i) = MakePt(_FL(i), _FT(i) + CDbl(_CapASuivre))
        Next
        _Gr.FillPolygon(_BrushCible, _FP)

        ' AGV
        For i As Integer = 0 To 5
            _CP(i) = MakePt(_CL(i), _CT(i) + CDbl(_CapCourant))
        Next
        _Gr.FillPolygon(_BrushChariot, _CP)

        ' Roue 1
        For i As Integer = 0 To 3
            _R1P(i) = MakePt(_R1L(i), _R1T(i) + CDbl(_CapCourant))
        Next
        _Gr.FillPolygon(_BrushRoue, _R1P)

        ' Roue 2
        For i As Integer = 0 To 3
            _R2P(i) = MakePt(_R2L(i), _R2T(i) + CDbl(_CapCourant))
        Next
        _Gr.FillPolygon(_BrushRoue, _R2P)

        ' Roue 3
        For i As Integer = 0 To 3
            _R3P(i) = MakePt(_R3L(i), _R3T(i) + CDbl(_CapCourant))
        Next
        _Gr.FillPolygon(_BrushRoue, _R3P)

        PictureBox1.Image = _Bmp
    End Sub

    Private Function ValueToStr(ByVal value As Integer) As String
        Dim a As Integer = Math.Floor(value / 26)
        Dim b As Integer = value - 26 * a
        Return Chr(a + 97) & Chr(b + 97)
    End Function

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        MyAgvs(0).Envoyer("#BS")
        Me.Close()
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Me.Vitesse.Value = Me.Vitesse.Minimum
        SendValues()
    End Sub

    Private Sub FormBoussole2_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        _StringFormatCardinales.LineAlignment = StringAlignment.Center
        _StringFormatCardinales.Alignment = StringAlignment.Center

        _CT(0) = Math.Atan((_CD1 - 2 * _CD3) / _CD2) * (180 / Math.PI)
        _CT(1) = 90 - Math.Atan((_CD2 - 2 * _CD3) / _CD1) * (180 / Math.PI)
        _CT(2) = 180 - Math.Atan(_CD1 / _CD2) * (180 / Math.PI)
        _CT(3) = -_CT(2)
        _CT(4) = -_CT(1)
        _CT(5) = -_CT(0)

        _CL(0) = Math.Sqrt(Math.Pow(_CD2 / 2, 2) + Math.Pow(_CD1 / 2 - _CD3, 2))
        _CL(1) = Math.Sqrt(Math.Pow(_CD1 / 2, 2) + Math.Pow(_CD2 / 2 - _CD3, 2))
        _CL(2) = Math.Sqrt(Math.Pow(_CD2 / 2, 2) + Math.Pow(_CD1 / 2, 2))
        _CL(3) = _CL(2)
        _CL(4) = _CL(1)
        _CL(5) = _CL(0)

        ' Cible
        _FT(0) = 5
        _FT(1) = 0
        _FT(2) = -_FT(0)

        _FL(0) = 0.85
        _FL(1) = 1
        _FL(2) = _FL(0)

        _R1L(0) = Math.Sqrt(Math.Pow(_RD3 + _RD1, 2) + Math.Pow(_RD2 / 2, 2))
        _R1L(1) = _R1L(0)
        _R1L(2) = Math.Sqrt(Math.Pow(_RD3, 2) + Math.Pow(_RD2 / 2, 2))
        _R1L(3) = _R1L(2)

        _R1T(0) = Math.Atan((_RD2 / 2) / (_RD3 + _RD1)) * (180 / Math.PI)
        _R1T(1) = -_R1T(0)
        _R1T(3) = Math.Atan((_RD2 / 2) / _RD3) * (180 / Math.PI)
        _R1T(2) = -_R1T(3)

        _R2L(0) = Math.Sqrt(Math.Pow(_RD4, 2) + Math.Pow(_RD5, 2))
        _R2L(1) = Math.Sqrt(Math.Pow(_RD4 + _RD2, 2) + Math.Pow(_RD5, 2))
        _R2L(2) = Math.Sqrt(Math.Pow(_RD4 + _RD2, 2) + Math.Pow(_RD5 + _RD1, 2))
        _R2L(3) = Math.Sqrt(Math.Pow(_RD4, 2) + Math.Pow(_RD5 + _RD1, 2))

        _R2T(0) = 180 + Math.Atan(_RD4 / _RD5) * (180 / Math.PI)
        _R2T(1) = 180 + Math.Atan((_RD4 + _RD2) / _RD5) * (180 / Math.PI)
        _R2T(2) = 180 + Math.Atan((_RD4 + _RD2) / (_RD5 + _RD1)) * (180 / Math.PI)
        _R2T(3) = 180 + Math.Atan(_RD4 / (_RD5 + _RD1)) * (180 / Math.PI)

        _R3L(0) = _R2L(0)
        _R3L(1) = _R2L(1)
        _R3L(2) = _R2L(2)
        _R3L(3) = _R2L(3)

        _R3T(0) = -_R2T(0)
        _R3T(1) = -_R2T(1)
        _R3T(2) = -_R2T(2)
        _R3T(3) = -_R2T(3)

        ' Rosace 1
        _X1P(0) = MakePt(_X1D1, 0)
        _X1P(1) = MakePt(_X1D2, 45)
        _X1P(2) = MakePt(_X1D1, 90)
        _X1P(3) = MakePt(_X1D2, 135)
        _X1P(4) = MakePt(_X1D1, 180)
        _X1P(5) = MakePt(_X1D2, 225)
        _X1P(6) = MakePt(_X1D1, 270)
        _X1P(7) = MakePt(_X1D2, 315)

        ' Rosace 2
        _X2P(0) = MakePt(_X2D1, 0)
        _X2P(1) = MakePt(_X2D2, 45)
        _X2P(2) = MakePt(_X2D1, 90)
        _X2P(3) = MakePt(_X2D2, 135)
        _X2P(4) = MakePt(_X2D1, 180)
        _X2P(5) = MakePt(_X2D2, 225)
        _X2P(6) = MakePt(_X2D1, 270)
        _X2P(7) = MakePt(_X2D2, 315)

        _Bmp = New Bitmap(PictureBox1.Width, PictureBox1.Height)
        _Gr = Graphics.FromImage(_Bmp)
        MyAgvs(0).Envoyer("BS")

        SetCapASuivre(0)

    End Sub

    Private Sub SendValues()
        MyAgvs(0).Envoyer("+" & ValueToStr(Me.Vitesse.Value) & ValueToStr(_CapASuivre))
    End Sub

    Private Sub Vitesse_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Vitesse.ValueChanged
        SendValues()
    End Sub

    Private Sub PictureBox1_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseUp

        Dim x As Double = (e.X - PictureBox1.Width / 2)
        Dim y As Double = (PictureBox1.Height / 2 - e.Y)
        Dim d As Double = Math.Sqrt(x * x + y * y)
        Dim _cos As Double = x / d
        Dim _sin As Double = y / d

        Dim Theta As Double = Math.Acos(_cos)
        If _sin < 0 Then
            Theta = -Theta
        End If

        Theta = Theta * 360 / (2 * Math.PI)
        Theta = -Theta + 90
        If Theta < 0 Then Theta = Theta + 360
        Me.SetCapASuivre(Theta)
        SendValues()

    End Sub

End Class