Imports Microsoft.DirectX.DirectInput

Public Class FormCalculateur

    Private _AncienX As Integer = 0
    Private _AncienY As Integer = 0
    Private _Js As Device

    Private _Bmp As Bitmap
    Private _Gr As Graphics

    Private Sub FormCalculateur_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ' Chargement de l'image
        '----------------------
        _Bmp = New Bitmap(PictureBox1.Width, PictureBox1.Height)
        _Gr = Graphics.FromImage(_Bmp)

        For Each instance As DeviceInstance In Manager.GetDevices(DeviceClass.GameControl, EnumDevicesFlags.AttachedOnly)
            _Js = New Device(instance.InstanceGuid)
            MsgBox(_Js.DeviceInformation.DeviceType)
            If _Js.DeviceInformation.DeviceType = DeviceType.Joystick Then
                Exit For
            Else
                _Js = Nothing
            End If
        Next

        If _Js Is Nothing Then
            MessageBox.Show("Aucun joystick trouv !")
            Me.Close()
            Exit Sub
        End If

        _Js.SetDataFormat(DeviceDataFormat.Joystick)
        '_Js.SetCooperativeLevel(Me, CooperativeLevelFlags.Exclusive Or CooperativeLevelFlags.Foreground)

        For Each d As DeviceObjectInstance In _Js.Objects
            If d.ObjectId And CInt(DeviceObjectTypeFlags.Axis) Then
                _Js.Properties.SetRange(ParameterHow.ById, d.ObjectId, New InputRange(-100, +100))
            End If
        Next d

        Timer1.Enabled = True

    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        ' Chargement du joystick
        Try
            _Js.Poll()
        Catch inputex As InputException
            If TypeOf inputex Is NotAcquiredException Or TypeOf inputex Is InputLostException Then
                Try
                    _Js.Acquire()
                Catch
                    Return
                End Try
            End If
        End Try

        ' Etat du joystick
        Dim State As New JoystickState()
        Try
            State = _Js.CurrentJoystickState
        Catch
            Return
        End Try

        ' Calculateur
        Dim Vitesse As Integer = 5
        Dim Course As Double = CDbl(100 - State.GetSlider()(0)) / 200

        If State.X * Course > _AncienX + Vitesse Then
            _AncienX = _AncienX + Vitesse
        ElseIf State.X * Course < _AncienX - Vitesse Then
            _AncienX = _AncienX - Vitesse

        Else
            _AncienX = State.X * Course
        End If

        If State.Y * Course > _AncienY + Vitesse Then
            _AncienY = _AncienY + Vitesse
        ElseIf State.Y * Course < _AncienY - Vitesse Then
            _AncienY = _AncienY - Vitesse
        Else
            _AncienY = State.Y * Course
        End If

        ' Affichage
        FormJoystick.LoadPosition(PictureBox1, _Bmp, _Gr, CDbl(State.X) / 100, -CDbl(State.Y) / 100, Color.Red, Point1.Checked, CDbl(_AncienX) / 100, -CDbl(_AncienY) / 100, Color.Green, Point2.Checked, Course, Course, Course, Course)

    End Sub


    Private Sub FormCalculateur_SizeChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.SizeChanged
        _Bmp = New Bitmap(PictureBox1.Width, PictureBox1.Height)
        _Gr = Graphics.FromImage(_Bmp)
    End Sub

End Class