Module LiaisonSerie

    Public WithEvents MyRs232 As System.IO.Ports.SerialPort

    Public Sub Load()

        MyRs232 = New System.IO.Ports.SerialPort()

        ' Configuration du port srie
        With MyRs232
            .PortName = My.Settings.SerialPort
            .BaudRate = 4800
            .DataBits = 8
            .Parity = IO.Ports.Parity.None
            .StopBits = IO.Ports.StopBits.One
            .ReadTimeout = 200
        End With

        ' Connexion
        Try
            MyRs232.Open()
            FormDebug.SerialDebug("INFO : Connect au port srie " & MyRs232.PortName)
        Catch ex As Exception
            FormDebug.SerialDebug("ERREUR : Impossible de se connecter au port " & MyRs232.PortName)
            FormDebug.ComBt.Enabled = False
            FormDebug.ComText.Enabled = False
        End Try

    End Sub

    Public Sub Envoyer(ByVal Message As String)
        FormDebug.SerialDebug("ENVOI : " & Message)
        MyRs232.Write(Message & Chr(13))
    End Sub

    Private Sub MyRs232_DataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles MyRs232.DataReceived
        Dim Message As String = MyRs232.ReadExisting
        FormDebug.SerialDebug("RECU : " & Message)

        ' Attribution d'un numro de mission
        If Message.StartsWith(" Numro de mission : ") Then
            ' Recherche de la dernire mission envoye
            For i As Integer = 0 To Missions.NbMissions - 1

                If Missions.Items(i).Etat = MissionState.Mission_Sent Then
                    Missions.Items(i).Etat = MissionState.Mission_Queued
                    Missions.Items(i).RefAgv = CInt(Strings.Mid(Message, 21))
                    Exit For
                End If

            Next
        End If

        ' Action en cours
        If Message.StartsWith("action en cours : ") Then
            ' Recherche de la mission en cours
            For i As Integer = 0 To Missions.NbMissions - 1

                ' Dbut d'une mission
                If Missions.Items(i).Etat = MissionState.Mission_Queued Then
                    Missions.Items(i).Etat = MissionState.Mission_Doing
                End If

                ' On avance dans la mission
                If Missions.Items(i).Etat = MissionState.Mission_Doing Then
                    Missions.Items(i).OrdresDone += Strings.Mid(Message, 18)
                    Exit For
                End If

            Next
        End If

    End Sub

End Module
