Module ModuleAxis

    Public Enabled As Boolean

    Private _CurY As Integer = 999
    Private _CurZ As Integer = 999
    Private _CurZoom As Integer = 999

    Private _YMin As Integer = -180
    Private _YMax As Integer = 180
    Private _ZMin As Integer = -90
    Private _ZMax As Integer = 30
    Private _ZoomMin As Integer = 0
    Private _ZoomMax As Integer = 178

    Private _AxisIp As String = "193.52.129.27"
    Private _Init As Boolean = False

    Public Enum AxisMove
        MoveHome
        MoveUp
        MoveDown
        MoveLeft
        MoveRight
        MoveUpLeft
        MoveUpRight
        MoveDownLeft
        MoveDownRight
    End Enum

    Public Enum AxisAutoFocus
        AutoFocusOn
        AutoFocusOff
    End Enum

    Public Class AxisPos
        Public Y As Integer
        Public Z As Integer
        Public Zoom As Integer
    End Class

    Public Sub DoAxisMove(ByVal Move As AxisMove, Optional ByVal MoveParam As Integer = 10)
        Select Case Move
            Case AxisMove.MoveHome
                _Init = False
                _AxisCmd("/axis-cgi/com/ptz.cgi?camera=1&move=home")
            Case AxisMove.MoveUp
                '_AxisCmd("/axis-cgi/com/ptz.cgi?camera=1&move=up")
                DoAxisGoto(GetAxisPos.Y, GetAxisPos.Z + MoveParam)
            Case AxisMove.MoveDown
                '_AxisCmd("/axis-cgi/com/ptz.cgi?camera=1&move=down")
                DoAxisGoto(GetAxisPos.Y, GetAxisPos.Z - MoveParam)
            Case AxisMove.MoveLeft
                '_AxisCmd("/axis-cgi/com/ptz.cgi?camera=1&move=left")
                DoAxisGoto(GetAxisPos.Y - MoveParam, GetAxisPos.Z)
            Case AxisMove.MoveRight
                '_AxisCmd("/axis-cgi/com/ptz.cgi?camera=1&move=right")
                DoAxisGoto(GetAxisPos.Y + MoveParam, GetAxisPos.Z)
            Case AxisMove.MoveUpLeft
                '_AxisCmd("/axis-cgi/com/ptz.cgi?camera=1&move=upleft")
                DoAxisGoto(GetAxisPos.Y - MoveParam, GetAxisPos.Z + MoveParam)
            Case AxisMove.MoveUpRight
                '_AxisCmd("/axis-cgi/com/ptz.cgi?camera=1&move=upright")
                DoAxisGoto(GetAxisPos.Y + MoveParam, GetAxisPos.Z + MoveParam)
            Case AxisMove.MoveDownLeft
                '_AxisCmd("/axis-cgi/com/ptz.cgi?camera=1&move=downleft")
                DoAxisGoto(GetAxisPos.Y - MoveParam, GetAxisPos.Z - MoveParam)
            Case AxisMove.MoveDownRight
                '_AxisCmd("/axis-cgi/com/ptz.cgi?camera=1&move=downright")
                DoAxisGoto(GetAxisPos.Y + MoveParam, GetAxisPos.Z - MoveParam)
        End Select
    End Sub

    Public Function GetAxisPos() As AxisPos
        Dim p As New AxisPos
        p.Y = _CurY
        p.Z = _CurZ
        p.Zoom = _CurZoom
        Return p
    End Function

    Public Sub SetAxisPos(ByVal pos As AxisPos)
        DoAxisZoom(pos.Zoom)
        DoAxisGoto(pos.Y, pos.Z)
    End Sub

    Public Sub DoAxisInit()
        _Init = True
        DoAxisZoom(0)
        DoAxisGoto(0, 0)
    End Sub

    Public Sub DoAxisGoto(ByVal y As Integer, ByVal z As Integer)
        If y <> _CurY Or z <> _CurZ Then
            _CurY = y
            _CurZ = z
            If _CurY < _YMin Then _CurY = _YMin
            If _CurY > _YMax Then _CurY = _YMax
            If _CurZ < _ZMin Then _CurZ = _ZMin
            If _CurZ > _ZMax Then _CurZ = _ZMax
            _AxisCmd("/axis-cgi/com/ptz.cgi?imagewidth=704&imageheight=576&camera=1&pan=" & _CurY & "&tilt=" & _CurZ)
        End If
    End Sub

    Public Sub DoAxisGotoY(ByVal y As Integer)
        If y <> _CurY Then
            _CurY = y
            If _CurY < _YMin Then _CurY = _YMin
            If _CurY > _YMax Then _CurY = _YMax
            _AxisCmd("/axis-cgi/com/ptz.cgi?imagewidth=704&imageheight=576&camera=1&pan=" & _CurY)
        End If
    End Sub

    Public Sub DoAxisGotoZ(ByVal z As Integer)
        If z <> _CurZ Then
            _CurZ = z
            If _CurZ < _ZMin Then _CurZ = _ZMin
            If _CurZ > _ZMax Then _CurZ = _ZMax
            _AxisCmd("/axis-cgi/com/ptz.cgi?imagewidth=704&imageheight=576&camera=1&tilt=" & _CurZ)
        End If
    End Sub

    Public Sub DoAxisZoom(ByVal Zoom As Integer) ' entre 0 et 178
        If Zoom <> _CurZoom Then
            _CurZoom = Zoom
            If _CurZoom < _ZoomMin Then _CurZoom = _ZoomMin
            If _CurZoom > _ZoomMax Then _CurZoom = _ZoomMax
            '_AxisCmd("/incl/specialzoomcmd.shtml?camNo=1&zoombar=100&coord=?" & _CurZoom & ",5")
            Dim _ValToSend As Integer
            If (CDbl(_CurZoom) / 178 <= 0.7) Then
                _ValToSend = CDbl(_CurZoom) * 5 / 7
            Else
                _ValToSend = (_CurZoom - 178 * 0.7) * 5 / 3 + 178 * 0.5
            End If
            _AxisCmd("/axis-cgi/com/ptz.cgi?camera=1&zoombar=178,horisontal&barcoord=" & _ValToSend & ",5")
        End If
    End Sub

    Public Sub DoAxisAutoFocus(ByVal AutoFocus As AxisAutoFocus)
        If AutoFocus = AxisAutoFocus.AutoFocusOn Then
            _AxisCmd("/axis-cgi/com/ptz.cgi?camera=1&autofocus=on")
        ElseIf AutoFocus = AxisAutoFocus.AutoFocusOff Then
            _AxisCmd("/axis-cgi/com/ptz.cgi?camera=1&autofocus=off")
        End If
    End Sub

    Private Sub _AxisCmd(ByVal cmd As String)
        If Not Enabled Then Exit Sub

        ' Sans proxy
        'Dim c As New TcpClient(_AxisIp, 80)
        'c.WriteLine("GET " & cmd & " HTTP/1.0")
        'c.WriteLine("Authorization: Basic cm9vdDpvZ3A=")
        'c.WriteLine("")

        ' Avec proxy
        Dim c As New TcpClient("172.21.160.20", 3128)
        c.WriteLine("GET http://" & _AxisIp & cmd & " HTTP/1.1")
        c.WriteLine("Host: " & _AxisIp)
        c.WriteLine("Authorization: Basic cm9vdDpvZ3A=")
        c.WriteLine("")

    End Sub

End Module
