Public Class Point

    ' numro du point
    Public Numero As Integer

    ' points suivants
    Public Successeurs As New Dictionary(Of String, Point)
    Public Distances As New Dictionary(Of String, Integer)
    Public Vitesses As New Dictionary(Of String, String)

    ' fontionnalits du point
    Public AllFunc As New List(Of String)

    ' Fichier ini
    Private IniFile As ClassIniReader

    Public Sub New(ByRef IniFile As ClassIniReader, ByVal Numero As Integer)
        Me.Numero = Numero
        Me.IniFile = IniFile
        Me.AllFunc.Add("LM")
    End Sub

    Public Property Cacher() As Boolean
        Get
            Return IniFile.ReadBoolean("Point" & CStr(Me.Numero), "Cacher", False)
        End Get
        Set(ByVal value As Boolean)
            IniFile.Write("Point" & CStr(Me.Numero), "Cacher", value)
        End Set
    End Property

    Public Property Description() As String
        Get
            Return IniFile.ReadString("Point" & CStr(Me.Numero), "Desc", "???")
        End Get
        Set(ByVal value As String)
            IniFile.Write("Point" & CStr(Me.Numero), "Desc", value)
        End Set
    End Property

    Public Function OrdreSpecial(ByVal Ordre As String) As String
        Return Ordre & IniFile.ReadString("Point" & CStr(Me.Numero), Ordre & "O", "")
    End Function

    Public Property Symbole() As String
        Get
            Return IniFile.ReadString("Point" & CStr(Me.Numero), "Symbole", "")
        End Get
        Set(ByVal value As String)
            IniFile.Write("Point" & CStr(Me.Numero), "Symbole", value)
        End Set
    End Property

    Public Property PosX() As Integer
        Get
            Return IniFile.ReadInteger("Point" & CStr(Me.Numero), "PosX", 0)
        End Get
        Set(ByVal value As Integer)
            IniFile.Write("Point" & CStr(Me.Numero), "PosX", value)
        End Set
    End Property

    Public Property PosY() As Integer
        Get
            Return IniFile.ReadInteger("Point" & CStr(Me.Numero), "PosY", 0)
        End Get
        Set(ByVal value As Integer)
            IniFile.Write("Point" & CStr(Me.Numero), "PosY", value)
        End Set
    End Property

    Public Sub FuncAdd(ByVal Func As String)
        Me.AllFunc.Add(Func)
        Me.IniFile.Write("Point" & CStr(Me.Numero), Func, True)
    End Sub

    Public Sub FuncRemove(ByVal Func As String)
        Me.AllFunc.Remove(Func)
        Me.IniFile.DeleteKey("Point" & CStr(Me.Numero), Func)
    End Sub

    Public Sub AddSuccesseur(ByVal Direction As String, ByRef Pt As Point, ByVal Vitesse As String, ByVal Distance As Integer)
        Me.Successeurs.Add(Direction, Pt)
        Me.Vitesses.Add(Direction, Vitesse)
        Me.Distances.Add(Direction, Distance)
    End Sub

    Public Sub EditSupprimerLien(ByVal Direction As String)
        Me.IniFile.DeleteKey("Point" & CStr(Me.Numero), Direction & "P")
        Me.IniFile.DeleteKey("Point" & CStr(Me.Numero), Direction & "V")
        Me.IniFile.DeleteKey("Point" & CStr(Me.Numero), Direction & "D")
        Me.Successeurs.Remove(Direction)
        Me.Vitesses.Remove(Direction)
        Me.Distances.Remove(Direction)
    End Sub

    Public Sub EditAjouterLien(ByVal Direction As String, ByRef Pt As Point, ByVal Vitesse As Integer, ByVal Distance As Integer)
        Me.IniFile.Write("Point" & CStr(Me.Numero), Direction & "P", Pt.Numero)
        Me.IniFile.Write("Point" & CStr(Me.Numero), Direction & "V", Vitesse)
        Me.IniFile.Write("Point" & CStr(Me.Numero), Direction & "D", Distance)
        Me.Successeurs.Add(Direction, Pt)
        Me.Vitesses.Add(Direction, Vitesse)
        Me.Distances.Add(Direction, Distance)
    End Sub

    Public Sub AxisLoad()
        If ModuleAxis.Enabled Then
            DoAxisZoom(Me.IniFile.ReadInteger("Point" & CStr(Me.Numero), "AXISZOOM", 0))
            DoAxisGoto(Me.IniFile.ReadInteger("Point" & CStr(Me.Numero), "AXISY", 0), Me.IniFile.ReadInteger("Point" & CStr(Me.Numero), "AXISZ", 0))
        End If
    End Sub

    Public Sub AxisSave()
        If ModuleAxis.Enabled Then
            Me.IniFile.Write("Point" & CStr(Me.Numero), "AXISY", GetAxisPos.Y)
            Me.IniFile.Write("Point" & CStr(Me.Numero), "AXISZ", GetAxisPos.Z)
            Me.IniFile.Write("Point" & CStr(Me.Numero), "AXISZOOM", GetAxisPos.Zoom)
        End If
    End Sub

End Class

Public Class Circuit

    ' Fonctionalits du circuit
    Public AllDest As New List(Of String)
    Public AllVit As New List(Of String)

    ' Utile juste pour les descriptions
    Public DescFunc As New System.Collections.Generic.Dictionary(Of String, String)

    Private PrivNomIni As String
    Private PrivNomPng As String
    Private IniFile As ClassIniReader

    Public Points() As Point
    Public Marge As Integer = 20

    Public Sub New(ByVal NomPng As String)

        FormPrincipale.Text = "Supervision AGV : " & System.IO.Path.GetFileNameWithoutExtension(NomPng)

        Me.PrivNomIni = System.IO.Path.GetDirectoryName(NomPng) & "\" & System.IO.Path.GetFileNameWithoutExtension(NomPng) & ".ini"
        Me.PrivNomPng = NomPng
        IniFile = New ClassIniReader(Me.PrivNomIni)

        ' Liste des fonctionalists du circuit
        ' ====================================
        Me.AllDest.Add("TD")
        Me.AllDest.Add("AI")
        Me.AllDest.Add("AG")
        Me.AllDest.Add("AD")
        Me.AllDest.Add("GT")
        Me.AllDest.Add("DT")
        Me.AllDest.Add("Z1")
        Me.AllDest.Add("Z2")
        Me.AllDest.Add("Z3")

        Me.AllVit.Add("1")
        Me.AllVit.Add("2")
        Me.AllVit.Add("3")
        Me.AllVit.Add("M")

        Me.DescFunc.Add("OP", "Action oprateur")
        Me.DescFunc.Add("DG", "Dcharger")
        Me.DescFunc.Add("DD", "Dcharger")
        Me.DescFunc.Add("CG", "Charger")
        Me.DescFunc.Add("CD", "Charger")
        Me.DescFunc.Add("CP", "Charger pal.")
        Me.DescFunc.Add("DP", "Dcharger pal.")

        ' Initialisation des points
        ' =========================
        For i As Integer = 0 To IniFile.GetSectionNames.Count - 1
            ReDim Preserve Points(Me.NbPoints)
            Me.Points(NbPoints - 1) = New Point(Me.IniFile, i)
        Next

        ' Trac du circuit
        ' ================
        For i As Integer = 0 To NbPoints - 1
            ' Fuccesseurs
            For Each Dest As String In Me.AllDest
                Dim SuivP As Integer = IniFile.ReadInteger("Point" & CStr(i), Dest & "P", -1)
                If SuivP <> -1 Then
                    Dim SuivV As String = IniFile.ReadString("Point" & CStr(i), Dest & "V", 1)
                    Dim SuivD As Integer = IniFile.ReadInteger("Point" & CStr(i), Dest & "D", 1)
                    Points(i).AddSuccesseur(Dest, Points(SuivP), SuivV, SuivD)
                End If
            Next
            ' Fonctions
            For Each f As String In Me.DescFunc.Keys
                If IniFile.ReadBoolean("Point" & CStr(i), f, False) Then
                    Points(i).AllFunc.Add(f)
                End If
            Next
        Next

    End Sub

    Public Function GetPointByRef(ByVal Ref As String) As Point
        For Each P As Point In Me.Points
            If P.Description.ToLower.Contains("(" & Ref.ToLower & ")") Then Return P
        Next
        Return Nothing
    End Function

    Public Sub DeletePoint(ByVal Pt As Integer)

        ' Suppressions de certains liens pointant vers le point
        For i As Integer = 0 To Me.NbPoints - 1
            For Each Dir As String In Me.AllDest
                If Me.Points(i).Successeurs.ContainsKey(Dir) Then
                    If Me.Points(i).Successeurs(Dir).Numero = Pt Then
                        Me.Points(i).Successeurs.Remove(Dir)
                        Me.Points(i).Distances.Remove(Dir)
                        Me.Points(i).Vitesses.Remove(Dir)
                    End If
                End If
            Next
        Next

        ' Changement des numros
        For i As Integer = Pt + 1 To Me.NbPoints - 1
            Me.Points(i).Numero -= 1
        Next

        ' Mise  jour du fichier ini
        For NewNum As Integer = 0 To Me.NbPoints - 2

            Dim OldNum As Integer
            If NewNum < Pt Then
                OldNum = NewNum
            Else
                OldNum = NewNum + 1
            End If

            ' Suppression de tous les liens
            For Each Dir As String In Me.AllDest
                Me.IniFile.DeleteKey("Point" & CStr(NewNum), Dir & "P")
                Me.IniFile.DeleteKey("Point" & CStr(NewNum), Dir & "D")
                Me.IniFile.DeleteKey("Point" & CStr(NewNum), Dir & "V")
            Next

            ' Dcalage des informations
            If OldNum <> NewNum Then
                Me.IniFile.Write("Point" & CStr(NewNum), "Desc", Me.IniFile.ReadString("Point" & CStr(OldNum), "Desc"))
                Me.IniFile.Write("Point" & CStr(NewNum), "Cacher", Me.IniFile.ReadBoolean("Point" & CStr(OldNum), "Cacher", False))
                Me.IniFile.Write("Point" & CStr(NewNum), "PosX", Me.IniFile.ReadInteger("Point" & CStr(OldNum), "PosX", 0))
                Me.IniFile.Write("Point" & CStr(NewNum), "PosY", Me.IniFile.ReadInteger("Point" & CStr(OldNum), "PosY", 0))
                Me.IniFile.Write("Point" & CStr(NewNum), "Symbole", Me.IniFile.ReadString("Point" & CStr(OldNum), "Symbole", ""))
            End If

            ' Ajout des liens
            For Each Dir As String In Me.Points(OldNum).Successeurs.Keys
                Me.IniFile.Write("Point" & CStr(NewNum), Dir & "P", Me.Points(OldNum).Successeurs(Dir).Numero)
                Me.IniFile.Write("Point" & CStr(NewNum), Dir & "D", Me.Points(OldNum).Distances(Dir))
                Me.IniFile.Write("Point" & CStr(NewNum), Dir & "V", Me.Points(OldNum).Vitesses(Dir))
            Next

        Next

        ' Suppression du dernier point
        Me.IniFile.DeleteSection("Point" & CStr(Me.NbPoints - 1))

        ' Dcalage des points
        For i As Integer = Pt To Me.NbPoints - 2
            Me.Points(i) = Me.Points(i + 1)
        Next

        ' Redimenssionnement
        ReDim Preserve Me.Points(0 To Me.NbPoints - 2)

    End Sub

    Public Sub NewPoint()
        ReDim Preserve Me.Points(0 To Me.NbPoints)
        Me.Points(Me.NbPoints - 1) = New Point(Me.IniFile, Me.NbPoints - 1)
    End Sub

    Public ReadOnly Property ImgFile() As String
        Get
            Return Me.PrivNomPng
        End Get
    End Property

    Public ReadOnly Property NbPoints() As Integer
        Get
            If Me.Points Is Nothing Then
                Return 0
            Else
                Return UBound(Me.Points) + 1
            End If
        End Get
    End Property

End Class

