Module ModuleTransport

    Public Function CalculResume(ByVal Agv As AgvGeneric, ByVal Depart As EtatAgv, ByVal Ordres As String) As String

        Dim R As String = "" 'Pt.Description & vbCrLf

        Dim PosCur As EtatAgv = Depart.Copy
        Dim EnMarche As Boolean = False
        Dim Ordre, OrdreSuivant As String
        Dim VitesseDemandee As String = ""

        For i As Integer = 0 To Int(Ordres.Length / 2) - 1
            ' Ordre
            Ordre = Strings.Mid(Ordres, 2 * i + 1, 2)

            ' Ordre suivant
            If i = Int(Ordres.Length / 2) - 1 Then
                OrdreSuivant = ""
            Else
                OrdreSuivant = Strings.Mid(Ordres, 2 * i + 3, 2)
            End If

            If Ordre = "DE" And Not EnMarche Then
                EnMarche = True
                Ordre = "TD"
            End If

            If Agv.AllDest.Contains(Ordre) And (Ordre = "DT" Or Ordre = "GT") And PosCur.Position.Successeurs.ContainsKey(Ordre) And Not EnMarche Then
                ' Demi tour = AGV capable * Ordre DT-GT * Point capable * Pas en marche
                VitesseDemandee = PosCur.Position.Vitesses(Ordre)
                If Agv.AllVit.Contains(VitesseDemandee) And PosCur.Vitesse <> VitesseDemandee Then Return R & "-" & vbCrLf & "Mission errone : mauvaise vitesse sur le tronon"

                PosCur.Position = PosCur.Position.Successeurs(Ordre)

                If OrdreSuivant <> "DE" Then R = R & ">> " & PosCur.Position.Description & vbCrLf

            ElseIf Agv.AllDest.Contains(Ordre) And PosCur.Position.Successeurs.ContainsKey(Ordre) And EnMarche Then
                ' Dplacement = AGV capable * Point capable * En marche
                VitesseDemandee = PosCur.Position.Vitesses(Ordre)
                If Agv.AllVit.Contains(VitesseDemandee) And PosCur.Vitesse <> VitesseDemandee Then Return R & "-" & vbCrLf & "Mission errone : mauvaise vitesse sur le tronon"

                PosCur.Position = PosCur.Position.Successeurs(Ordre)

            ElseIf Agv.AllFunc.Contains(Ordre) And PosCur.Position.AllFunc.Contains(Ordre) And Not EnMarche Then
                ' Fonction = AGV capable * Point capable * Pas en marche
                If MyCircuit.DescFunc.ContainsKey(Ordre) Then R = R & MyCircuit.DescFunc(Ordre) & vbCrLf

            ElseIf Agv.AllVit.Contains(Ordre.Substring(1, 1)) And Ordre.StartsWith("V") Then
                ' Changement de vitesse = Agv capable * Ordre V? 
                PosCur.Vitesse = Ordre.Substring(1, 1)
                'R = R & "Vitesse " & Strings.Mid(Ordre, 2, 1) & vbCrLf

            ElseIf Ordre = "AR" And EnMarche And Not PosCur.Position.Cacher Then
                ' Arrt : Ordre AR * EnMarche * Pas sur un point cach
                EnMarche = False
                If Not (OrdreSuivant = "DT" Or OrdreSuivant = "GT") Then R = R & ">> " & PosCur.Position.Description & vbCrLf

            Else
                ' Mauvais ordre
                Return R & "-" & vbCrLf & "Mission errone : fonction '" & Strings.Mid(Ordres, 2 * i + 1) & "' inconnue" & vbCrLf & "AGV " & Microsoft.VisualBasic.Switch(EnMarche, "en marche", True, "arrt") & " au point '" & PosCur.Position.Description & "'" & vbCrLf

            End If
        Next

        ' Mission errone
        If Ordres.Length / 2 <> Int(Ordres.Length / 2) Then
            Return R & "-" & vbCrLf & "Mission errone : fonction '" & Strings.Mid(Ordres, Ordres.Length) & "' inconnue" & vbCrLf & "AGV " & Microsoft.VisualBasic.Switch(EnMarche, "en marche", True, "arrt") & " au point '" & PosCur.Position.Description & "'" & vbCrLf
        ElseIf EnMarche Then
            Return R & "-" & vbCrLf & "Mission errone : AGV " & Microsoft.VisualBasic.Switch(EnMarche, "en marche", True, "arrt") & " au point '" & PosCur.Position.Description & "'" & vbCrLf
        End If

        Return R

    End Function

    Public Function CalculMission(ByVal Agv As AgvGeneric, ByVal Depart As EtatAgv, ByRef Arrivee As Point, Optional ByVal Silencieux As Boolean = False) As String

        ' Construction d'un nouveau circuit
        ' =================================
        ' le fait qu'on ne puisse pas dmarer avec un AI ou un TD
        ' nous fait recrer un point qui sera le point de dpart avec
        ' des capacicits limites

        Dim Infini As Integer = 999999 ' doit tre plus grand que le sup de tous les circuits

        ' On construit un nouveau point de dpart fictif
        Dim Depart2 As Point = New Point(Nothing, MyCircuit.NbPoints)
        For Each Direction As String In Depart.Position.Successeurs.Keys
            If Direction = "TD" Or Direction = "DT" Or Direction = "GT" Then
                Depart2.AddSuccesseur(Direction, MyCircuit.Points(Depart.Position.Successeurs(Direction).Numero), Depart.Position.Vitesses(Direction), Depart.Position.Distances(Direction))
            End If
        Next

        ' Circuit avec le point de dpart
        Dim Points2(0 To MyCircuit.NbPoints) As Point
        For i As Integer = 0 To MyCircuit.NbPoints - 1
            Points2(i) = MyCircuit.Points(i)
        Next
        Points2(MyCircuit.NbPoints) = Depart2

        ' Algo de recherche d'itinraire
        ' ==============================

        Dim Poids(0 To MyCircuit.NbPoints) As Integer
        Dim Marque(0 To MyCircuit.NbPoints) As Boolean
        Dim Pred(0 To MyCircuit.NbPoints) As Integer

        ' initialisation
        For i As Integer = 0 To MyCircuit.NbPoints
            Poids(i) = Infini ' poid  l'infini
            Marque(i) = False ' sommets non marqus
            Pred(i) = -1
        Next
        Poids(Depart2.Numero) = 0

        Dim PointMini As Integer
        Dim PoidMini As Integer

        For i As Integer = 0 To MyCircuit.NbPoints

            ' recherche du sommet non marqu de poid mini
            PointMini = -1
            PoidMini = Infini
            For j As Integer = 0 To MyCircuit.NbPoints
                If Marque(j) = False And Poids(j) < PoidMini Then
                    PoidMini = Poids(j)
                    PointMini = j
                End If
            Next
            If PoidMini = Infini Then Exit For
            Marque(PointMini) = True

            ' met  jour les successeurs
            For Each Direction As String In Agv.AllDest
                If Points2(PointMini).Successeurs.ContainsKey(Direction) Then
                    If Poids(PointMini) + Points2(PointMini).Distances(Direction) < Poids(Points2(PointMini).Successeurs(Direction).Numero) Then
                        Poids(Points2(PointMini).Successeurs(Direction).Numero) = Poids(PointMini) + Points2(PointMini).Distances(Direction)
                        Pred(Points2(PointMini).Successeurs(Direction).Numero) = PointMini
                    End If
                End If
            Next

        Next

        ' Pas de chemin possible
        ' ======================
        If Poids(Arrivee.Numero) = Infini Then
            If Not Silencieux Then MsgBox("Impossible d'aller  ce point avec cet AGV", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly)
            Return ""
        End If

        ' Construction de la chaine de la mission
        ' =======================================

        ' calcul de la mission (avec juste des TD/AI/DT/GT)
        Dim Trajet As String = ""
        Dim PtCur As Point = Points2(Arrivee.Numero)
        While PtCur.Numero <> Depart2.Numero
            For Each Direction As String In Points2(Pred(PtCur.Numero)).Successeurs.Keys
                If Points2(Pred(PtCur.Numero)).Successeurs(Direction).Numero = PtCur.Numero Then
                    Trajet = Direction + Trajet
                    Exit For
                End If
            Next
            PtCur = Points2(Pred(PtCur.Numero))
        End While

        ' on repasse la mission en ajoutant les DE/AR/V#
        Dim PosCur As EtatAgv = Depart.Copy
        Dim Trajet2 As String = ""
        Dim EnMarche As Boolean = False

        For i As Integer = 0 To Trajet.Length / 2 - 1
            Dim Ordre As String = Strings.Mid(Trajet, 2 * i + 1, 2)

            ' On change de vitesse si besoin
            If PosCur.Vitesse <> PosCur.Position.Vitesses(Ordre) And Agv.AllVit.Contains(PosCur.Position.Vitesses(Ordre)) Then
                Trajet2 &= "V" + PosCur.Position.Vitesses(Ordre)
                PosCur.Vitesse = PosCur.Position.Vitesses(Ordre)
            End If

            ' Ajout de l'ordre  la mission finale
            If Not EnMarche And Ordre = "TD" Then
                ' Dmarage
                Trajet2 &= "DE"
                EnMarche = True
            ElseIf EnMarche And (Ordre = "DT" Or Ordre = "GT") Then
                ' Arrt avant un DT
                Trajet2 &= "AR" & Ordre
                EnMarche = False
            Else
                ' Autre ordre
                Trajet2 &= Ordre
            End If

            PosCur.Position = PosCur.Position.Successeurs(Ordre)

        Next

        If EnMarche Then Trajet2 &= "AR"

        ' On retourne le texte de la mission
        Return Trajet2

    End Function

    Public Function CalculEtatFinal(ByVal Agv As AgvGeneric, ByVal Depart As EtatAgv, ByVal Ordres As String) As EtatAgv

        ' Mauvaise longueur de mission
        If Ordres.Length = 0 Or Ordres.Length / 2 <> Int(Ordres.Length / 2) Then Return Nothing

        Dim PosCur As EtatAgv = Depart.Copy
        Dim EnMarche As Boolean = False
        Dim VitesseDemandee As String = ""

        For i As Integer = 0 To Int(Ordres.Length / 2) - 1
            ' Ordre
            Dim Ordre As String = Strings.Mid(Ordres, 2 * i + 1, 2)

            If Ordre = "DE" And Not EnMarche Then
                EnMarche = True
                Ordre = "TD"
            End If

            If Agv.AllDest.Contains(Ordre) And (Ordre = "DT" Or Ordre = "GT") And PosCur.Position.Successeurs.ContainsKey(Ordre) And Not EnMarche Then
                ' Demi tour = AGV capable * Ordre DT-GT * Point capable * Pas en marche
                VitesseDemandee = PosCur.Position.Vitesses(Ordre)
                If Agv.AllVit.Contains(VitesseDemandee) And PosCur.Vitesse <> VitesseDemandee Then Return Nothing
                PosCur.Position = PosCur.Position.Successeurs(Ordre)

            ElseIf Agv.AllDest.Contains(Ordre) And PosCur.Position.Successeurs.ContainsKey(Ordre) And EnMarche Then
                ' Dplacement = AGV capable * Point capable * En marche
                VitesseDemandee = PosCur.Position.Vitesses(Ordre)
                If Agv.AllVit.Contains(VitesseDemandee) And PosCur.Vitesse <> VitesseDemandee Then Return Nothing
                PosCur.Position = PosCur.Position.Successeurs(Ordre)

            ElseIf Agv.AllFunc.Contains(Ordre) And PosCur.Position.AllFunc.Contains(Ordre) And Not EnMarche Then
                ' Fonction = AGV capable * Point capable * Pas en marche

            ElseIf Agv.AllVit.Contains(Ordre.Substring(1, 1)) And Ordre.StartsWith("V") Then
                ' Changement de vitesse = Agv capable * Ordre V? 
                PosCur.Vitesse = Ordre.Substring(1, 1)

            ElseIf Ordre = "AR" And EnMarche Then
                ' Arrt : Ordre AR * EnMarche * Pas sur un point cach
                EnMarche = False

            Else
                ' Mauvais ordre
                Return Nothing

            End If
        Next

        PosCur.EnMarche = EnMarche

        Return PosCur

    End Function

    Public Function IsMissionValide(ByVal Agv As AgvGeneric, ByVal Depart As EtatAgv, ByVal Ordres As String) As Boolean
        Dim e As EtatAgv = CalculEtatFinal(Agv, Depart, Ordres)
        If e Is Nothing Then Return False
        If e.EnMarche Then Return False
        If e.Position.Cacher Then Return False
        Return True
    End Function

End Module
