Public Class FormMissionAuto

    ' Position actuelle de l'AGV
    Private _Agv As AgvGeneric
    Private _Position As EtatAgv = Nothing

    ' Mission en cours
    Private _Mission As String = ""

    ' Liste des boutons
    Private _Pts(0 To MyCircuit.NbPoints - 1) As System.Windows.Forms.Button
    Private _Func As New Dictionary(Of String, System.Windows.Forms.Button)

    Public Sub New(ByVal Agv As AgvGeneric)
        ' Cet appel est requis par le Concepteur Windows Form.
        InitializeComponent()
        ' Ajoutez une initialisation quelconque aprs l'appel InitializeComponent().
        Me._Agv = Agv
    End Sub

    Private Sub FormMissionAuto_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ' Vrification nombre de missions
        If Me._Agv.NbMissions = 0 Then
            MsgBox("Il faut commencer par dfinir la position de l'AGV", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly)
            Me.Close()
            Exit Sub
        ElseIf Me._Agv.LastMission.Etat = MissionGeneric.Etats.Mission_Cancelled Then
            MsgBox("Il faut commencer par dfinir la position de l'AGV", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly)
            Me.Close()
            Exit Sub
        End If

        ' Chargement de l'image de fond
        Dim Bmp1 As Bitmap = New Bitmap(MyCircuit.ImgFile)
        Dim Bmp2 As Bitmap = New Bitmap(Bmp1.Width + 2 * MyCircuit.Marge, Bmp1.Height + 2 * MyCircuit.Marge + 30)
        Dim Gr As Graphics = Graphics.FromImage(Bmp2)
        Gr.DrawImage(Bmp1, New Rectangle(MyCircuit.Marge, MyCircuit.Marge, Bmp1.Width, Bmp1.Height))

        With Me.PictureCircuit
            .Top = 0
            .Left = 0
            .Height = Bmp2.Height
            .Width = Bmp2.Width
            .Image = Bmp2
        End With

        ' Chargement des boutons
        ReDim _Pts(0 To MyCircuit.NbPoints - 1)
        For i As Integer = 0 To MyCircuit.NbPoints - 1
            _Pts(i) = New System.Windows.Forms.Button
            Me.Controls.Add(_Pts(i))
            With _Pts(i)
                .Name = "PtP" + CStr(i)
                .Height = 25
                .Width = 20
                .FlatStyle = FlatStyle.Flat
                .BackColor = Color.LightGreen
                .Left = MyCircuit.Points(i).PosX + MyCircuit.Marge
                .Top = MyCircuit.Points(i).PosY + MyCircuit.Marge
                .Text = MyCircuit.Points(i).Symbole
                AddHandler .Click, AddressOf Pts_Click
                If MyCircuit.Points(i).Cacher Then .Hide()
            End With
        Next

        ' Boutons d'action
        For Each f As String In MyCircuit.DescFunc.Keys
            Me._Func.Add(f, New Button)
            Me.Controls.Add(Me._Func(f))
            With Me._Func(f)
                .Margin = Me.BtAnnuler.Margin
                .Name = f
                .Height = Me.BtAnnuler.Height
                .Width = 100
                .FlatStyle = FlatStyle.Flat
                .BackColor = Color.LightGreen
                .Text = MyCircuit.DescFunc(f)
                AddHandler .Click, AddressOf PtAction_Click
            End With
        Next

        ' On met l'image en arrire plan
        Me.PictureCircuit.SendToBack()

        ' Nouvelle mission
        _Position = Me._Agv.LastMission.PositionFinale
        Recolorier()

    End Sub

    Private Sub Pts_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

        ' recherche du numro
        Dim i As Integer = System.Array.IndexOf(_Pts, sender)

        If CalculMission(Me._Agv, _Position, MyCircuit.Points(i)) = "" Then Exit Sub

        ' arrive
        'If i <> Position Then
        Me._Mission = _Mission & CalculMission(Me._Agv, _Position, MyCircuit.Points(i))
        Me._Position = CalculEtatFinal(Me._Agv, Me._Agv.LastMission.PositionFinale, Me._Mission)
        Me.Recolorier()
        'End If

    End Sub

    Private Sub Recolorier()

        ' Coloriage des boutons
        For i As Integer = 0 To MyCircuit.NbPoints - 1
            If Not IsNothing(_Pts(i)) Then
                If _Position.Position.Numero = i Then
                    _Pts(i).BackColor = Color.LightGreen
                Else
                    _Pts(i).BackColor = Color.LightBlue
                End If
            End If
        Next

        ' Masquage des points inaccessibles
        For Each Pt As Point In MyCircuit.Points
            If Pt.Cacher Or CalculMission(Me._Agv, Me._Position, Pt, True) = "" Then
                Me._Pts(Pt.Numero).Visible = False
            Else
                Me._Pts(Pt.Numero).Visible = True
            End If
        Next

        ' Affichage des boutons d'action
        Dim Pos As Point
        If _Mission = "" Then
            Pos = Me._Agv.LastMission.PositionFinale.Position
        Else
            Pos = CalculEtatFinal(Me._Agv, Me._Agv.LastMission.PositionFinale, Me._Mission).Position
        End If
        Dim l As Integer = 3
        Dim h As Integer = Me.BtAnnuler.Top
        For Each f As String In MyCircuit.DescFunc.Keys
            If Pos.AllFunc.Contains(f) And Me._Agv.AllFunc.Contains(f) Then
                Me._Func(f).Visible = True
                Me._Func(f).Left = l
                Me._Func(f).Top = h
                l += Me._Func(f).Width + 3
                'h -= Me._Func(f).Height + 3
            Else
                Me._Func(f).Visible = False
            End If
        Next

    End Sub

    Private Sub PtAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim Bt As Button = sender
        Me._Mission &= Bt.Name
        Bt.Visible = False
    End Sub

    Private Sub BtAnnuler_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtAnnuler.Click
        Me.Close()
    End Sub

    Private Sub BtRun_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtRun.Click
        ' Lancement de la mission
        Me._Agv.NouvelleMission(_Mission)
        Me.Close()
    End Sub

End Class