Public Class EtatAgv

    Public Position As Point
    Public Vitesse As String
    Public EnMarche As Boolean

    Public Function Copy() As EtatAgv
        Dim e As New EtatAgv
        e.EnMarche = Me.EnMarche
        e.Position = Me.Position
        e.Vitesse = Me.Vitesse
        Return e
    End Function

End Class

Public Class MissionGeneric

    ' Etat de la mission
    Friend _Etat As Etats = Etats.Mission_Sent
    ' Rfrence dans l'AGV
    Private _RefAgv As Integer = -1
    ' Mission
    Friend _Ordres As String
    Private _OrdresDone As String = ""
    ' Dates
    Private _DateDebut As System.DateTime
    Private _DateFin As System.DateTime
    ' Distance
    Private _Distance As Double = 0
    ' AGV
    Friend _Agv As AgvGeneric

    Public Enum Etats
        Mission_Sent
        Mission_SendError
        Mission_Queued
        Mission_Doing
        Mission_Done
        Mission_Cancelled
        Recalage_Manuel
    End Enum

    Public Sub New(ByRef Agv As AgvGeneric, ByVal Ordres As String)
        ' AGV de la mission
        Me._Agv = Agv
        ' Ordres de la mission
        If Ordres.StartsWith("#") Then
            ' Dplacement manuel
            Me._Etat = Etats.Recalage_Manuel
            Me._Ordres = Strings.Mid(Ordres, 2)
        Else
            ' Enregistrement des ordres
            Me._Ordres = Ordres
            If Me._Agv.AllFunc.Contains("LM") Then Me._Ordres &= "LM"
            Dim SpOrdres As String = Me._Agv.RemplaceOrdresSpeciaux(Me._Agv.LastMission.PositionFinale, Me._Ordres)
            Try
                Me._Agv.Envoyer(SpOrdres)
            Catch ex As Exception
                Me._Etat = Etats.Mission_SendError
            End Try
        End If
    End Sub

    Public ReadOnly Property Agv() As AgvGeneric
        Get
            Return _Agv
        End Get
    End Property

    Public Property Etat() As Etats
        Get
            Return _Etat
        End Get
        Set(ByVal value As Etats)

            ' dbut de mission
            If _Etat = Etats.Mission_Queued And value = Etats.Mission_Doing Then
                Me._DateDebut = Date.Now
                FormPrincipale.ListMissions.SelectedIndex = FormPrincipale.AllMissions.IndexOf(Me)
            End If

            ' fin de mission
            If _Etat = Etats.Mission_Doing And value = Etats.Mission_Done Then
                Me._DateFin = Date.Now
            End If

            If value = Etats.Mission_Cancelled Then
                _OrdresDone = _Ordres
            End If

            ' enregistrement
            _Etat = value
            FormPrincipale.RefreshList()

        End Set
    End Property

    Public ReadOnly Property EtatString() As String
        Get
            Select Case Me.Etat
                Case Etats.Mission_Sent
                    Return "envoye"
                Case Etats.Mission_SendError
                    Return "erreur d'envoi"
                Case Etats.Mission_Queued
                    Return "reue"
                Case Etats.Mission_Doing
                    Return "en cours"
                Case Etats.Mission_Done
                    Return "termine"
                Case Etats.Mission_Cancelled
                    Return "annule"
                Case Etats.Recalage_Manuel
                    Return "recalage"
                Case Else
                    Return "?"
            End Select
        End Get
    End Property

    Public Property RefAgv() As Integer
        Get
            If Me.Etat = Etats.Mission_Doing Or Me.Etat = Etats.Mission_Queued Then
                Return _RefAgv
            Else
                Return -1
            End If
        End Get
        Set(ByVal value As Integer)
            _RefAgv = value
        End Set
    End Property

    Public ReadOnly Property Ordres() As String
        Get
            Return _Ordres
        End Get
    End Property

    Public Property OrdresDone() As String
        Get
            Return _OrdresDone
        End Get
        Set(ByVal value As String)
            _OrdresDone = value
            If _OrdresDone = _Ordres Then
                Me.Etat = MissionGeneric.Etats.Mission_Done
            End If
            FormPrincipale.RefreshList()

            ' Position camra
            If ModuleAxis.Enabled Then
                Dim e As EtatAgv
                If Me.OrdresDone.Length < 2 Then
                    e = Me.PositionInitiale
                Else
                    e = CalculEtatFinal(Me.Agv, Me.PositionInitiale, _OrdresDone.Substring(0, _OrdresDone.Length - 2))
                End If
                If e IsNot Nothing Then e.Position.AxisLoad()
            End If

        End Set
    End Property

    Public Property Distance() As Double
        Get
            Return _Distance
        End Get
        Set(ByVal value As Double)
            _Distance = value
            If FormPrincipale.ListMissions.SelectedIndex = FormPrincipale.AllMissions.IndexOf(Me) Then
                FormPrincipale.RefreshList()
            End If
        End Set
    End Property

    Public ReadOnly Property PositionInitiale() As EtatAgv
        Get
            Return Me._Agv.Missions(Me._Agv.Missions.LastIndexOf(Me) - 1).PositionFinale
        End Get
    End Property

    Public ReadOnly Property PositionFinale() As EtatAgv
        Get
            If Me.Etat = Etats.Recalage_Manuel Then
                Dim e As New EtatAgv
                e.Position = MyCircuit.Points(CInt(Me.Ordres))
                e.Vitesse = ""
                e.EnMarche = False
                Return e
            Else
                Return CalculEtatFinal(Me._Agv, Me.PositionInitiale, Me.Ordres)
            End If
        End Get
    End Property

    Public ReadOnly Property TitreListe() As String
        Get
            ' Dplacement manuel
            If Me.Etat = Etats.Recalage_Manuel Then
                Return "AGV n" & CStr(MyAgvs.IndexOf(Me._Agv) + 1) & " : Dplacement manuel : " & Me.PositionFinale.Position.Description
            End If

            ' Mission AGV
            Return "AGV n" & CStr(MyAgvs.IndexOf(Me._Agv) + 1) & " : Mission n" & CStr(Me.IdMission) & " (" & Me.EtatString & ")"
        End Get
    End Property

    Public ReadOnly Property TitreRapport() As String
        Get
            Return "AGV n" & CStr(MyAgvs.IndexOf(Me._Agv) + 1) & " : Rapport de mission n" & CStr(Me.IdMission)
        End Get
    End Property

    Public Sub RichRapport(ByRef RR As System.Windows.Forms.RichTextBox)
        RR.Clear()

        ' Etat
        RR.SelectionFont = New Font(RR.Font.Name, RR.Font.Size, FontStyle.Underline Or FontStyle.Bold)
        RR.AppendText("Etat :")
        RR.SelectionFont = New Font(RR.Font.Name, RR.Font.Size, FontStyle.Regular)
        RR.AppendText(" " & Me.EtatString)

        ' Rsum
        RR.AppendText(vbCrLf & vbCrLf)
        RR.SelectionFont = New Font(RR.Font.Name, RR.Font.Size, FontStyle.Underline Or FontStyle.Bold)
        RR.AppendText("Rsum :" & vbCrLf)
        RR.AppendText(CalculResume(Me._Agv, Me.PositionInitiale, Me.Ordres))

        ' Ordres
        RR.AppendText(vbCrLf)
        RR.SelectionFont = New Font(RR.Font.Name, RR.Font.Size, FontStyle.Underline Or FontStyle.Bold)
        RR.AppendText("Ordres :" & vbCrLf)
        Dim i As Integer
        For i = 0 To (Me.Ordres.Length / 2 - 1)
            If i <> 0 Then
                RR.AppendText(" ")
            End If
            If (Me.Etat = Etats.Mission_Doing) And (i = Me.OrdresDone.Length / 2 - 1) Then RR.SelectionColor = Color.Red
            RR.SelectionFont = New Font("Lucida Console", RR.Font.Size, FontStyle.Regular)
            RR.AppendText(Strings.Mid(Ordres, 2 * i + 1, 2))
            If i = Me.OrdresDone.Length / 2 - 1 Then RR.SelectionColor = Color.Black
        Next i

        ' Rfrence d'AGV
        If False And Me.RefAgv <> -1 Then
            RR.AppendText(vbCrLf & vbCrLf)
            RR.SelectionFont = New Font(RR.Font.Name, RR.Font.Size, FontStyle.Underline Or FontStyle.Bold)
            RR.AppendText("Ref AGV :")
            RR.SelectionFont = New Font(RR.Font.Name, RR.Font.Size, FontStyle.Regular)
            RR.AppendText(" " & Me.RefAgv)
        End If

        ' Heure de dbut
        RR.SelectionTabs = New Integer() {50}
        If Me._DateDebut.ToBinary Then
            RR.AppendText(vbCrLf & vbCrLf)
            RR.SelectionFont = New Font(RR.Font.Name, RR.Font.Size, FontStyle.Underline Or FontStyle.Bold)
            RR.AppendText("Dbut :")
            RR.SelectionFont = New Font(RR.Font.Name, RR.Font.Size, FontStyle.Regular)
            RR.AppendText(vbTab & Me._DateDebut.ToString("H:mm:ss"))
        End If

        ' Heure de fin
        If Me._DateFin.ToBinary Then
            ' Heure de fin
            RR.AppendText(vbCrLf)
            RR.SelectionFont = New Font(RR.Font.Name, RR.Font.Size, FontStyle.Underline Or FontStyle.Bold)
            RR.AppendText("Fin :")
            RR.SelectionFont = New Font(RR.Font.Name, RR.Font.Size, FontStyle.Regular)
            RR.AppendText(vbTab & Me._DateFin.ToString("H:mm:ss"))
            ' Dure de la mission
            RR.AppendText(vbCrLf)
            RR.SelectionFont = New Font(RR.Font.Name, RR.Font.Size, FontStyle.Underline Or FontStyle.Bold)
            RR.AppendText("Dure :")
            RR.SelectionFont = New Font(RR.Font.Name, RR.Font.Size, FontStyle.Regular)
            RR.AppendText(vbTab & CInt((Me._DateFin - Me._DateDebut).TotalSeconds) & " secondes")
        End If

        ' Distance parcourue
        If Me.Distance <> 0 Then
            ' Heure de fin
            RR.AppendText(vbCrLf & vbCrLf)
            RR.SelectionFont = New Font(RR.Font.Name, RR.Font.Size, FontStyle.Underline Or FontStyle.Bold)
            RR.AppendText("Distance parcourue :")
            RR.SelectionFont = New Font(RR.Font.Name, RR.Font.Size, FontStyle.Regular)
            RR.AppendText(" " & Math.Round(Me.Distance, 2) & " mtres")
        End If

    End Sub

    Private ReadOnly Property IdMission() As Integer
        ' Numro de la mission (on ne compte pas les recalages)
        Get
            If Me._Agv.Missions.IndexOf(Me) = 0 Then
                Return 0
            ElseIf Me.Etat = Etats.Recalage_Manuel Then
                Return Me._Agv.Missions(Me._Agv.Missions.IndexOf(Me) - 1).IdMission
            Else
                Return Me._Agv.Missions(Me._Agv.Missions.IndexOf(Me) - 1).IdMission + 1
            End If
        End Get
    End Property

End Class

Public Class AgvGeneric

    Public AllDest As New List(Of String)
    Public AllFunc As New List(Of String)
    Public AllVit As New List(Of String)
    Public Missions As New List(Of MissionGeneric)
    Public Rs232 As Rs232Generic


    Public ReadOnly Property NbMissions() As Integer
        Get
            Return Me.Missions.Count
        End Get
    End Property

    Public ReadOnly Property LastMission() As MissionGeneric
        Get
            If Me.Missions.Count = 0 Then
                LastMission = Nothing
            Else
                LastMission = Me.Missions(Me.Missions.Count - 1)
            End If
        End Get
    End Property

    Public Delegate Sub dRefreshList()
    Public Sub NouvelleMission(ByVal Ordres As String)

        ' Il faut commencer par un recalage
        If NbMissions = 0 Then
            MsgBox("Il faut d'abord faire un recalage manuel !", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly)
            Exit Sub
        End If

        ' Dernire mission annule
        If LastMission.Etat = MissionGeneric.Etats.Mission_Cancelled Then
            MsgBox("Il faut d'abord faire un recalage manuel !", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly)
            Exit Sub
        End If

        ' Mission invalide
        If Not IsMissionValide(Me, LastMission.PositionFinale, Ordres) Then
            MsgBox("Mission invalide (" & Ordres & ") !", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly)
            Exit Sub
        End If

        ' Mission trop longue
        If Len(Ordres) > 98 Then ' on met 100 - 2 pour ajouter le LM  la fin
            MsgBox("Mission trop longue !", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly)
            Exit Sub
        End If

        ' Cration de la mission
        Me.Missions.Add(New MissionGeneric(Me, Ordres))
        _FormPrincipale.AllMissions.Add(Me.LastMission)
        _FormPrincipale.Invoke(New dRefreshList(AddressOf _FormPrincipale.RefreshList))

    End Sub

    Public Sub NouveauRecalage(ByVal Pt As Point)

        ' Annulation des missions en cours
        For i As Integer = 0 To Me.NbMissions - 1
            With Me.Missions(i)
                If .Etat = MissionGeneric.Etats.Mission_Doing Or .Etat = MissionGeneric.Etats.Mission_Queued Or .Etat = MissionGeneric.Etats.Mission_Sent Then
                    .Etat = MissionGeneric.Etats.Mission_Cancelled
                End If
            End With
        Next

        ' Recalage
        Me.Missions.Add(New MissionGeneric(Me, "#" & CStr(Pt.Numero)))
        _FormPrincipale.AllMissions.Add(Me.LastMission)
        _FormPrincipale.Invoke(New dRefreshList(AddressOf _FormPrincipale.RefreshList))

    End Sub

    Public Function RemplaceOrdresSpeciaux(ByVal Depart As EtatAgv, ByVal Ordres As String) As String
        Dim PosCur As EtatAgv = Depart.Copy
        Dim Trajet2 As String = ""
        For i As Integer = 0 To Ordres.Length / 2 - 1
            Dim Ordre As String = Strings.Mid(Ordres, 2 * i + 1, 2)
            Trajet2 &= PosCur.Position.OrdreSpecial(Ordre)
            If Ordre = "DE" Then Ordre = "TD"
            If PosCur.Position.Successeurs.ContainsKey(Ordre) Then PosCur.Position = PosCur.Position.Successeurs(Ordre)
        Next
        Return Trajet2
    End Function

    Overridable Sub DetectionObstacle()
    End Sub

    Overridable Sub ChocBouclier()
    End Sub

    Overridable Sub ArretUrgence()
    End Sub

    Overridable Sub Rearmement()
    End Sub

    Overridable Sub Envoyer(ByVal Msg As String)
    End Sub

End Class

Public Class AgvCubloc
    Inherits AgvGeneric

    Public Sub New(ByVal IdAgv As Integer, ByRef MyRs232 As Rs232Cubloc)
        Me.Rs232 = MyRs232
        AllDest.Add("TD")
        AllDest.Add("AR")
        AllDest.Add("AI")
        AllDest.Add("AG")
        AllDest.Add("AD")
        AllDest.Add("DT")
        AllDest.Add("GT")

        AllFunc.Add("OP")
        AllFunc.Add("LM")
        AllFunc.Add("CP")
        AllFunc.Add("DP")

        AllVit.Add("M")
        AllVit.Add("1")
        AllVit.Add("2")
        AllVit.Add("3")
    End Sub

    Overrides Sub Envoyer(ByVal Msg As String)
        Me.Rs232.Envoyer(Msg)
    End Sub

    Overrides Sub DetectionObstacle()
        FormPrincipale.SymboleObstacle.Visible = True
    End Sub

    'Private Sub TimerObstacle_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles TimerObstacle.Tick
    'SymboleObstacle.Visible = False
    'TimerObstacle = Nothing
    'End Sub

    Overrides Sub ChocBouclier()
        FormPrincipale.SymboleBouclier.Visible = True
    End Sub

    Overrides Sub ArretUrgence()
        FormPrincipale.SymboleArretUrgence.Visible = True
    End Sub

    Overrides Sub Rearmement()
        FormPrincipale.SymboleBouclier.Visible = False
        FormPrincipale.SymboleArretUrgence.Visible = False
        FormPrincipale.SymboleObstacle.Visible = False
    End Sub

End Class

Public Class AgvAutomate
    Inherits AgvGeneric

    Public Sub New(ByRef MyRs232 As Rs232Automate)
        Me.Rs232 = MyRs232
        AllDest.Add("TD")
        AllDest.Add("AR")
        AllDest.Add("AI")

        AllFunc.Add("CG")
        AllFunc.Add("DG")
        AllFunc.Add("CD")
        AllFunc.Add("DD")
    End Sub

    Overrides Sub Envoyer(ByVal Msg As String)
        Dim MaxLen As Integer = 12
        Msg &= "FF"
        For i As Integer = 0 To Math.Floor(Len(Msg) / MaxLen)
            'MsgBox("MM01" & Msg.Substring(MaxLen * i, Math.Min(12, Len(Msg) - MaxLen * i)))
            Me.Rs232.Envoyer("MM01" & Msg.Substring(MaxLen * i, Math.Min(12, Len(Msg) - MaxLen * i)))
        Next
    End Sub

End Class

Public Class Rs232Generic

    Public _FormPrincipale As FormPrincipale
    Public WithEvents MyRs232 As New System.IO.Ports.SerialPort
    'Private Delegate Sub dSerialReception(ByVal Reception As String)
    Private SerialBuf As String = ""

    Public Overridable Sub Envoyer(ByVal Message As String)
        If MyRs232.IsOpen Then MyRs232.Write(Message & Chr(13))
    End Sub

    Public Delegate Sub dReception(ByVal Reception As String)
    Private Sub MyRs232_DataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles MyRs232.DataReceived
        ' On invoque une fonction depuis la fentre, sinon les donnes ne sont pas accessibles
        Dim Message As String = MyRs232.ReadExisting
        _FormPrincipale.Invoke(New dReception(AddressOf Reception), Message)
        'Me.Reception(Message)
    End Sub

    Overridable Sub Reception(ByVal Message As String)
        For i As Integer = 1 To Strings.Len(Message)
            Select Case Strings.Asc(Strings.Mid(Message, i, 1))
                Case 13
                    ' saut de ligne
                    Me.ReceptionLigne(SerialBuf)
                    SerialBuf = ""
                Case 10
                    ' caractre muet
                Case Else
                    ' autre caractre
                    'FormDebug.SerialDebug("!" & Strings.Mid(Message, i, 1) & " : " & CStr(Strings.Asc(Strings.Mid(Message, i, 1))))
                    SerialBuf += Strings.Mid(Message, i, 1)
            End Select
        Next
    End Sub

    Overridable Sub ReceptionLigne(ByVal Ligne As String)
    End Sub

End Class

Public Class Rs232Cubloc
    Inherits Rs232Generic

    Public Sub New(ByVal PortName As String, ByRef F As FormPrincipale)
        Me._FormPrincipale = F

        ' Paramtrage de la liaison srie
        Me.MyRs232.PortName = PortName
        Me.MyRs232.BaudRate = 19200
        Me.MyRs232.DataBits = 8
        Me.MyRs232.Parity = IO.Ports.Parity.None
        Me.MyRs232.StopBits = IO.Ports.StopBits.One
        Me.MyRs232.ReadTimeout = 200

        ' Ouvertur du port
        Try
            Me.MyRs232.Open()
            Me.MyRs232.DtrEnable = True ' utile quand on utilise com0com
            FormDebug1.SerialDebug("# Connect au port srie " & MyRs232.PortName)
        Catch ex As Exception
            FormDebug1.SerialDebug("# Impossible de se connecter au port " & MyRs232.PortName)
            FormDebug1.ComBt.Enabled = False
            FormDebug1.ComText.Enabled = False
        End Try

    End Sub

    Public Overrides Sub Envoyer(ByVal Message As String)
        FormDebug1.SerialDebug("> " & Message)
        If MyRs232.IsOpen Then MyRs232.Write(Message & Chr(13))
    End Sub

    Overrides Sub ReceptionLigne(ByVal Ligne As String)
        'MyBase.ReceptionLigne(Ligne)
        'MsgBox(Ligne)

        ' Affichage de la ligne
        If Ligne <> "" Then
            FormDebug1.SerialDebug("< " & Ligne)
        End If

        Dim MyAgv As AgvGeneric = MyAgvs(0)

        If Ligne = "DETECTION OBSTACLE" Then
            MyAgv.DetectionObstacle()

        ElseIf Ligne = "INITIALISATION EFFECTUEE" Then
            ' Annulation des missions en cours
            For i As Integer = 0 To MyAgv.NbMissions - 1
                With MyAgv.Missions(i)
                    If .Etat = MissionGeneric.Etats.Mission_Doing Or .Etat = MissionGeneric.Etats.Mission_Queued Or .Etat = MissionGeneric.Etats.Mission_Sent Then
                        .Etat = MissionGeneric.Etats.Mission_Cancelled
                    End If
                End With
            Next
            ' rarmement
            MyAgv.Rearmement()

        ElseIf Ligne = "ARRET URGENCE" Then
            MyAgv.ArretUrgence()

        ElseIf Ligne = "CHOC BOUCLIER" Then
            MyAgv.ChocBouclier()

        ElseIf Ligne = "ACQUITTEMENT" Then
            MyAgv.Rearmement()

        ElseIf Ligne.StartsWith("NUMERO DE MISSION : ") Then
            ' Recherche de la dernire mission envoye
            For i As Integer = 0 To MyAgv.NbMissions - 1
                If MyAgv.Missions(i).Etat = MissionGeneric.Etats.Mission_Sent Then
                    MyAgv.Missions(i).Etat = MissionGeneric.Etats.Mission_Queued
                    MyAgv.Missions(i).RefAgv = CInt(Ligne.Split(" ")(4))
                    Exit For
                End If
            Next

        ElseIf Ligne.StartsWith("ACTION EN COURS : ") Then
            ' Recherche de la mission en cours
            For i As Integer = 0 To MyAgv.NbMissions - 1
                ' Dbut d'une mission
                If MyAgv.Missions(i).Etat = MissionGeneric.Etats.Mission_Queued Then
                    MyAgv.Missions(i).Etat = MissionGeneric.Etats.Mission_Doing
                End If
                ' On avance dans la mission
                If MyAgv.Missions(i).Etat = MissionGeneric.Etats.Mission_Doing Then
                    If MyAgv.Missions(i).Ordres.StartsWith(MyAgv.Missions(i).OrdresDone & Ligne.Split(" ")(4)) Then
                        MyAgv.Missions(i).OrdresDone &= Ligne.Split(" ")(4)
                    Else
                        ' ordre n'apparetnant pas  la mission en cours
                    End If
                    Exit For
                End If
            Next

        ElseIf Ligne.StartsWith("DISTANCE PARCOURUE : ") Then
            Dim dist As Double = CDbl(Ligne.Split(" ")(3).Replace(".", ","))
            ' Recherche de la mission en cours
            For i As Integer = MyAgv.NbMissions - 1 To 0 Step -1
                If MyAgv.Missions(i).Etat = MissionGeneric.Etats.Mission_Done Then
                    If MyAgv.Missions(i).Distance = 0 Then
                        MyAgv.Missions(i).Distance = dist
                    End If
                    Exit For
                End If
            Next

        ElseIf Ligne.StartsWith("CAP COURANT : ") Then
            If Not FormPrincipale.MyFormBoussole Is Nothing Then
                'FormPrincipale.MyFormBoussole.CapCourant.Text = CStr(Math.Round(CDbl(Ligne.Split(" ")(3).Replace(".", ","))))
                FormPrincipale.MyFormBoussole.SetCapCourant(Math.Round(CDbl(Ligne.Split(" ")(3).Replace(".", ","))))
            End If

        ElseIf Ligne.StartsWith("VITESSE NOMINALE =") Then
            FormInfoAgv.LblVitNom.Text = Ligne.Substring(18)

        ElseIf Ligne.StartsWith("VITESSE APPROCHE =") Then
            FormInfoAgv.LblVitApp.Text = Ligne.Substring(18)

        ElseIf Ligne.StartsWith("TEMPS AVEUGLE    =") Then
            FormInfoAgv.LblTempsAveugle.Text = Ligne.Substring(18)

        ElseIf Ligne.StartsWith("ACCELERATION     =") Then
            FormInfoAgv.LblAcc.Text = Ligne.Substring(18)

        ElseIf Ligne.StartsWith("DISTANCE TOTALE  =") Then
            FormInfoAgv.LblDst.Text = CStr(Math.Round(CDbl(Ligne.Substring(18).Replace(".", ",")), 2)) & " mtres"

        ElseIf Ligne = "PASSAGE EN MODE GUIDE EFFECTUE" Then
            'Me.Mode.Text = "Mode guid"
            'Me.Refresh()

        ElseIf Ligne = "PASSAGE EN MODE AVEUGLE EFFECTUE" Then
            'Me.Mode.Text = "Mode aveugle"
            'Me.Refresh()

        End If

    End Sub

End Class

Public Class Rs232Automate
    Inherits Rs232Generic

    Public Overrides Sub Envoyer(ByVal Message As String)
        FormDebug2.SerialDebug("> " & Message)
        If MyRs232.IsOpen Then MyRs232.Write(Message & Chr(13))
    End Sub

    Public Sub New(ByVal PortName As String, ByRef F As FormPrincipale)
        Me._FormPrincipale = F

        ' Paramtrage de la liaison srie
        Me.MyRs232.PortName = PortName
        Me.MyRs232.BaudRate = 1200
        Me.MyRs232.DataBits = 8
        Me.MyRs232.Parity = IO.Ports.Parity.None
        Me.MyRs232.StopBits = IO.Ports.StopBits.One
        Me.MyRs232.ReadTimeout = 2000

        ' Ouvertur du port
        Try
            Me.MyRs232.Open()
            Me.MyRs232.DtrEnable = True ' utile quand on utilise com0com
            FormDebug2.SerialDebug("# Connect au port srie " & MyRs232.PortName)
        Catch ex As Exception
            FormDebug2.SerialDebug("# Impossible de se connecter au port " & MyRs232.PortName)
        End Try

    End Sub

    Overrides Sub Reception(ByVal Message As String)
        'MsgBox("=" & Message)
        FormDebug2.SerialDebug(Message)
    End Sub

End Class