Public Class TcpClient

    Private _RemoteIp As String
    Private _RemotePort As Integer

    Private _TcpClient As System.Net.Sockets.TcpClient
    Private _Stream As System.Net.Sockets.NetworkStream
    Private _RecvBuf As String = ""
    Private _ClientThread As Threading.Thread
    Private _ContinueProcess As Boolean

    Event Receive(ByVal Text As String)
    Event ReceiveLine(ByVal Text As String)

    Public Sub New(ByVal RemoteIp As String, ByVal RemotePort As Integer)
        _RemoteIp = RemoteIp
        _RemotePort = RemotePort
        Try
            ' client
            _TcpClient = New System.Net.Sockets.TcpClient
            _TcpClient.Connect(_RemoteIp, _RemotePort)
            _Stream = _TcpClient.GetStream
            ' process de reception
            _ContinueProcess = True
            _ClientThread = New Threading.Thread(New Threading.ThreadStart(AddressOf _DoProcess))
            _ClientThread.Start()
        Catch ex As System.Net.Sockets.SocketException
        End Try
    End Sub

    Public Sub Close()
        _ContinueProcess = False
    End Sub

    Private Sub _DoProcess()
        ' Data buffer for incoming data.
        Dim bytes As Byte()
        If Not (_TcpClient Is Nothing) Then
            _TcpClient.ReceiveTimeout = 100  ' 1000 miliseconds
            While _ContinueProcess
                ReDim bytes(_TcpClient.ReceiveBufferSize)
                Try
                    Dim BytesRead As Integer = _Stream.Read(bytes, 0, _TcpClient.ReceiveBufferSize)
                    If BytesRead > 0 Then
                        Dim data As String = System.Text.Encoding.UTF7.GetString(bytes, 0, BytesRead)
                        _Receive(data)
                    End If
                Catch e As System.IO.IOException ' Timeout
                Catch e As System.Net.Sockets.SocketException
                    ''break()
                End Try
                Threading.Thread.Sleep(200)
            End While
            _TcpClient.Close()
            _Stream = Nothing
            _TcpClient = Nothing
        End If
    End Sub

    Private Sub _Receive(ByVal Txt As String)
        If Txt = "" Then Return
        RaiseEvent Receive(Txt)

        _RecvBuf &= Txt
        _RecvBuf = _RecvBuf.Replace(vbCrLf, vbCr) ' .Replace(vbLf, vbCr)

        Dim _RecvBuf2 As String = ""
        For Each c As String In _RecvBuf.ToCharArray
            If c = vbBack Then
                If Not _RecvBuf2.EndsWith(vbCr) And _RecvBuf2 <> "" Then
                    _RecvBuf2 = _RecvBuf2.Substring(0, _RecvBuf2.Length - 1)
                End If
            Else
                _RecvBuf2 &= c
            End If
        Next
        _RecvBuf = _RecvBuf2

        While _RecvBuf.Contains(vbCr)
            RaiseEvent ReceiveLine(_RecvBuf.Substring(0, _RecvBuf.IndexOf(vbCr)))
            _RecvBuf = _RecvBuf.Substring(_RecvBuf.IndexOf(vbCr) + 1)
        End While

    End Sub

    Public Sub Write(ByVal Txt As String)
        Dim sendBytes As Byte() = System.Text.Encoding.ASCII.GetBytes(Txt)
        _Stream.Write(sendBytes, 0, sendBytes.Length)
        _Stream.Flush()
    End Sub

    Public Sub WriteLine(ByVal Txt As String)
        Me.Write(Txt & vbCrLf)
    End Sub

End Class
